;-SYSTEM CORE : STORES/READS BASIC INITS...

Procedure __INIT_USER()


_ioID= ReadFile(#PB_Any,_core$+"user.crc")

If _ioID<>0
        
                    While Not Eof(_ioID)
                      _key$=ReadString(_ioID)
                      _value$=ReadString(_ioID)
                    
                               Select _key$
                            
                                 Case "SYSTEMTEXT"
                                  _system_text_base$=_value$
                                      Case "ATOMSYSTEM"
                                      _atom$=_value$
                                        Case "GRIDSIZE"
                                         _grid_height=Val(_value$)
                                          _grid_width=Val(_value$)
                                          Case "MATRIXSIZE"
                                          _matrix_size.l=Val(_value$)
                                          If _matrix_size>_matrix_system_max.l
                                              _matrix_size=_matrix_system_max.l
                                          EndIf
                                          ;not used in this version (hardcoded at ENV)
                                            Case "MATRIX_OFFSET_X"
                                            _grid_offset_x=Val(_value$)
                                              Case "MATRIX_OFFSET_Y"
                                              _grid_offset_y=Val(_value$)
                                                                                           
                                              Case "USEDEBUGLOG"
                                              _use_debug_log.b=Val(_value$)
                                              
                                              Case "SCRSWITCHMS"
                                              _level_switch.l=Val(_value$)
                                              
                                              Case "BLOOM"
                                              _bloom.b=Val(_value$)
                                              
                                              Case "FRAMECOLLISION"
                                              _collision_check_type.b=Val(_value$)
                                              
                                              Case "CODECS"
                                              _codec_path$=_value$
                                              
                                              Case "GFX"
                                              _2dgfx_path$=_value$ 
                                              _2dgfx_path_backup$=_value$ 
                                              
                                              Case "EFFECT_GFX"
                                              
                                              _2d_effect_gfx_path.s=_value$
                                              
                                              Case "AREACOLLISION"
                                              _area_collision.b=Val(_value$)
                                              
                                              Case "MAXOBJECTS"
                                              _maxworldftile=Val(_value$)
                                              
                                              Case "COREBRAIN"
                                              _brain_skript.s=_value$
                                              
                                              Case "DEBUGLOG"
                                              _debug_path.s=_value$
                                              
                                              Case "SIMCORE"
                                              _level_path$=_value$
                                              
                                              Case "GLOBAL_GFX_FX"
                                              GLOBAL_GFX_FX.b=Val(_value$)
                                              
                                              Case "FONTFUNDAMENT"
                                              _fontFundament.s=_value$  
                                              
                                               Case "FONT"
                                              _font.s=_value$  
                                              
                                              Case "SOURCEWIDTH"
                                              _defWidth=ValF(_value$)
                                             
                                              Case "ANIMSYSTEM"
                                              _anim_path$=_value$ ;the internal animpath for the engine 
                                              
                                              Case "MAXANIMFRAMES"
                                              _maxanimframes.l=Val(_value$)
                                              
                                              Case "SOURCEHEIGHT"
                                              _defHeight=ValF(_value$)
                                              
                                              Case "SOUNDPATH"
                                              _sound_path$=_value$
                                              
                                              Case "FILELOADMUSIC"
                                              _fileLoadMusicFile.s=_value$
                                              
                                              Case "LOADPIC"
                                              _loadScreen.b=Val(_value$)
                                              
                                              Case "GUI"
                                              _gui_path.s=_value$
                                              
                                              Case "IOPREFETCH"
                                              _doPrefetch.b=Val(_value$)
                                              
                                              
                                              Case "ERRORPATH"
                                              _err_log$=_value$
                                              
                                              Case "WARNINGS"
                                              _warn_log$=_value$
                                              
                                              Case "USRSCROLL"
                                              _usr_scroll.b=Val(_value$)
                                              
                                              Case "VERSION"
                                              _ver$=_value$
                                              
                                              Case "DYNAMICSCROLL"
                                              _dynamic_scroll.b=Val(_value$)  ;0= no dynamic scrolling (controled by player character)
                                              
                                            Case "PIP"
                                            _pip.b=Val(_value$)
                                            
                                            
                                             Case "APPENTRY"
                                              _app_entry_point.l=Val(_value$)
                                              _gameLEVEL=_app_entry_point.l
                                            
                                            
                                            Case "APPMODE"
                                            _app_mode$=_value$
                                            
                                            
                                           
                                            
                                            Case "APPSMOOTH"
                                            _screen_smooth.b=Val(_value$)
                                             
                                             Case "MULTITASK" ;engine setting for multitask (0=off, >0 = EngineDelay(value)
                                             _multitask.b=Val(_value$)
                                             
                                             If _multitask.b>127
                                             _multitask.b=127
                                             EndIf
                                             
                                             If _multitask.b<0
                                             _multitask.b=0
                                             EndIf
                                             
                                             _multitask_backup.b=_multitask.b
                                            
                                             Case "PATH"
                                             _in_grid_settings.s=_value$
                                             
                                           
                                             
                                             Case "VSYNC"
                                              _vwait=Val(_value$)
                                              
                                              Case "MAXPLAYERS"
                                              _max_players.l=Val(_value$)
                                              
                                              Case "FULLSCREEN"
                                              _full_screen.f=ValF(_value$)
                                              
                                              
                                              Case "WINDOWW"
                                                _window_w.l=Val(_value$)
                                                
                                              Case "WINDOWH"
                                                _window_h.l=Val(_value$)  
                                                
                                                
                                                 Case "USEWINDOWHD"
                                                _window_hd.b=Val(_value$)  
                                              
                                              Case "TEXTSMOOTH"
                                              _text_smooth.b=Val(_value$)
                                              
                                              ;1=true
                                              ;<>1 = false
                                              
                                              Case "CLEARSCREEN"
                                              _clear_screen.b=Val(_value$) 
                                              If _clear_screen.b=1
                                              _clear_screen.b=#True
                                              Else
                                              _clear_screen.b=#False
                                              EndIf
                           
                                                                                         
                                                                              
                                  
                               EndSelect
                            
                    
                    Wend
                    CloseFile(_ioID)
                    
EndIf



EndProcedure


Procedure __SETTINGS_LOG(_in_grid_settings.s)
Define ok.l=0

 ok=OpenFile(#PB_Any, _in_grid_settings.s)
 
If ok<>0
WriteStringN(ok,"ENGINE LOCAL BASE: "+_core$)

; 
; If _server_mode<>"LOCAL"
; If _found_server.l<>0
; WriteStringN(ok,"ENGINE SERVER BASE: "+_server_mode+_server_entry_point)
; WriteStringN(ok,"SERVER HELLO: "+_server_mode+_server_entry_point+_hello$)
; WriteStringN(ok,"IN_GRID SETTINGS FOR ACTUAL SESSION:")
; WriteStringN(ok,"SOUNDS LOCATED: "+i_sound_path$)
; WriteStringN(ok,"SOUND CODEC: "+_sound_codec$)
; WriteStringN(ok,"2DGFX LOCATED: "+i_2dgfx_path$)
; WriteStringN(ok,"GFX CODEC: "+_gfx_codec$)
; WriteStringN(ok,"ANIMS LOCATED: "+i_anim_path$)
; WriteStringN(ok,"MAPS LOCATED: "+i_level_path$)
; WriteStringN(ok,"ENGINE BASE: "+_core$)
; 
; Else
; WriteStringN(ok,"CONNECTION TO "+_server_mode+" FAILED")
; WriteStringN(ok," ")
; WriteStringN(ok,"IN_GRID SETTINGS FOR ACTUAL SESSION:")
; WriteStringN(ok,"SOUNDS LOCATED: "+_sound_path$)
; WriteStringN(ok,"SOUND CODEC: "+_sound_codec$)
; WriteStringN(ok,"2DGFX LOCATED: "+_2dgfx_path$)
; WriteStringN(ok,"GFX CODEC: "+_gfx_codec$)
; WriteStringN(ok,"ANIMS LOCATED: "+_anim_path$)
; WriteStringN(ok,"MAPS LOCATED: "+_level_path$)
; WriteStringN(ok,"ENGINE BASE: "+_core$)
; EndIf
; EndIf




WriteStringN(ok," ")
WriteStringN(ok,"IN_GRID SETTINGS FOR ACTUAL SESSION:")
WriteStringN(ok,"SOUNDS LOCATED: "+_sound_path$)
WriteStringN(ok,"SOUND CODEC: "+_sound_codec$)
WriteStringN(ok,"2DGFX LOCATED: "+_2dgfx_path$)
WriteStringN(ok,"GFX CODEC: "+_gfx_codec$)
WriteStringN(ok,"ANIMS LOCATED: "+_anim_path$)
WriteStringN(ok,"MAPS LOCATED: "+_level_path$)
WriteStringN(ok,"ENGINE BASE: "+_core$)




CloseFile(ok)

EndIf

EndProcedure

Procedure __DEBUG(_w$)

Define _err_date$="",ok=0
If _use_debug_log.b=1
_err_date$=FormatDate("%yyyy,%mm,%dd  TIME:%hh:%ii:%ss", Date()) 

ok= OpenFile(#PB_Any,_debug_path.s)
If ok<>0
;go to the last entry!!!!
While Not Eof(ok)
dummy$=ReadString(ok)
Wend
;add entry to list!!!
WriteStringN(ok,_w$)
CloseFile(ok)
EndIf
EndIf  ;use it? or not!


EndProcedure



Procedure __WARNINGS(_w$)

Define _err_date$="",ok=0

If  _use_debug_log.b=1 
_err_date$=FormatDate("%yyyy,%mm,%dd  TIME:%hh:%ii:%ss", Date()) 

ok= OpenFile(#PB_Any,_warn_log$)
If ok<>0
;go to the last entry!!!!
While Not Eof(ok)
dummy$=ReadString(ok)
Wend
;add entry to list!!!

WriteStringN(ok,"Warning:")
WriteStringN(ok,"Following Situation Caused This Warning:")
WriteStringN(ok,"")
WriteStringN(ok,"PARASITE-ENGINE-WARNING:DATE:"+_err_date$)
WriteStringN(ok,_w$)
WriteStringN(ok,"Program/Engine Is Continued")
WriteStringN(ok,"To Awoid Warnings Add Needed File(s) Or Use Correct Path/Data")
WriteStringN(ok,"This Situation Is NOT Critical, Engine / Application Will Work Fine, But Without The Missing Data")
WriteStringN(ok,"")
CloseFile(ok)

 _inwarn.s=_w$
EndIf

EndIf ;use it?



EndProcedure

Procedure __CORE_MANAGER()
;handles ERRORS/WARNINGS...
Define _err_file$="",_err_description$="",_err_date$="",ok=0,i=0,ispart.b=0
_engine_error.b=1  ;we got errors????
_err_date$=FormatDate("%yyyy,%mm,%dd  TIME:%hh:%ii:%ss", Date()) 


ok= OpenFile(#PB_Any,_err_log$)
If ok<>0
;go to the last entry!!!!
While Not Eof(ok)
dummy$=ReadString(ok)
Wend
;add entry to list!!!

If ispart.b=0
WriteStringN(ok,"THIS ERROR IS MAP/SEGMENT CONTENT ERROR  PLEASE CHECK CONTENT(FILES):")
WriteStringN(ok,"CHECK ******* SECTION FOR DETAILS, THANK YOU")
EndIf
WriteStringN(ok,"--------------------------------------------------------------------------------------------------")
WriteStringN(ok,"-PARASITE-ENGINE- ERROR HANDLER: ERROR DATE:"+_err_date$)
WriteStringN(ok,GetErrorDescription())
WriteStringN(ok,"Module:"+GetErrorModuleName()+" AT LINE:"+Str(GetErrorLineNR()))
WriteStringN(ok,"FATAL ERROR,CAN NOT CONTINUE IN_GRID_CORE, PLEASE CONTACT DEVELOPER")
WriteStringN(ok,"HOST-SYSTEMINFO: ")
WriteStringN(ok,"DESKTOPWIDTH: "+Str(DesktopWidth(0)))
WriteStringN(ok,"DESKTOPHEIGHT: "+Str(DesktopHeight(0)))
WriteStringN(ok,"DESKTOPDEPTH: "+Str(DesktopDepth(0)))
WriteStringN(ok,"ACTUAL MAP ID# "+Str(_actualLEVEL))
WriteStringN(ok,"NEXT MAP ID#"+Str(_gameLEVEL))
WriteStringN(ok,"I/O STOPPED AT ID: "+Str(_worldftile))
WriteStringN(ok,"OBJECTS IN MAP: "+Str(_object_s))
WriteStringN(ok,"LAST OBJECT LOAD: "+_3DGFXOBJECT(_worldftile)\worldFTileName)
WriteStringN(ok,"OBJECT SPRITE3D ID  "+Str(_3DGFXOBJECT(_worldftile)\worldFTileGFX))

WriteStringN(ok,"******************************************************************")
WriteStringN(ok,"LAST MAP SEGMENT: "+_level_path$+Str(_actualLEVEL)+"\"+Str(_i))
WriteStringN(ok,"TRYED TO LOAD:"+_engine_2dsprt$)
WriteStringN(ok,"AT MAP SEGMENT LINE: "+Str(_engine_parse_line.l))
If ispart.b=0
WriteStringN(ok,_engine_2dsprt$+" IS NOT PART OF THE GFXSYSTEM")
EndIf
WriteStringN(ok,"******************************************************************")
WriteStringN(ok,"OBJECT USE ANIMCONTAINER: "+_3DGFXOBJECT(_worldftile)\animContainer)
WriteStringN(ok,"OBJECT USE SOUNDFILE: "+_3DGFXOBJECT(_worldftile)\worldFTileSoundFile)
WriteStringN(ok,"OBJECT SOUND ID: "+Str(_3DGFXOBJECT(_worldftile)\worldFTileSoundIndex))
WriteStringN(ok,"I/O PREFETCH "+Str(_doPrefetch.b))
WriteStringN(ok,"USE LOAD SCREEN(ANIM) "+Str(_loadScreen))
WriteStringN(ok,"PLEASE SEND THIS INFO: suppooord@live.de OR POST INFO ON DEVELOPERs BOARD")
WriteStringN(ok,"")
CloseFile(ok)
EndIf


;*************** FOR DEVELOPEMENT USE - CHANGE SETTINGS FOR RELEASEVERSION (KEEP ERRORS QUIET IF POSSIBLE; BECAUSE OF THE ENGINE SIZE THERE MAY BE SOME HIDDEN BUGS )


;If GetErrorLineNR()>298 And GetErrorLineNR()<434  ;the area where the gfx is blittet in the FWORLD
OnErrorResume() ;some blitterproblems...we try to skip them: the graphicsdata will be updated by the engine and so it may happen that we get a valid state, if not we have 
;ProcedureReturn
;graphic on screen or we have not. there could be some errata in tiles graphics
;EndIf
;ok=MessageRequester("IN_GRID ERRORHANDLER","Something went wrong, check "+_err_log$+" for details please"+Chr(10)+"**********debug/continue**********",#PB_MessageRequester_YesNo)

; Select ok
; Case  #PB_MessageRequester_Yes 
; OnErrorResume()
; Case  #PB_MessageRequester_No
; End
; EndSelect

EndProcedure

Procedure __SHOW_ERROR(_error_code.b)
Define ok=0
ok=MessageRequester("PARASITE ENGINE CORE ERROR:",_error_text$(_error_code.b))
ok=MessageRequester("PARASITE ENGINE INFORMATION","Sorry,Dear User: PARASITE ENGINE  has to quit, because of the error")
End  ;quit because of error and free al resources
EndProcedure

Procedure __CODEC_CONTROL(_key$,_value$)
;now check the values....

Select _key$
      
      Case "GFXCODEC"
      _gfx_codec$=_value$
      Case "SOUNDCODEC"
      _sound_codec$=_value$
      Case "MUSICCODEC"
      _music_codec$=_value$


EndSelect

      


EndProcedure

Procedure __CODEC_PARSER(_codec_path$)
Define _brace$=""
_ioID=ReadFile(#PB_Any,_codec_path$)

If _ioID<>0

        ;parse:
        While Not Eof(_ioID)
        _key$=ReadString(_ioID)
        _brace$=ReadString(_ioID)
        _value$=ReadString(_ioID)
        _brace$=ReadString(_ioID)
        __CODEC_CONTROL(_key$,_value$)
        Wend
        CloseFile(_ioID)
EndIf

EndProcedure


Procedure __GET_ERRCODE()
;here we use the parser to get all needed infos


_ioID=ReadFile(#PB_Any,_system_text_base$)

        If _ioID<>0
        
        
             While Not Eof(_ioID)
                
                
        _key$=ReadString(_ioID)
        _value$=ReadString(_ioID)
                          
                     Select _key$
                          
                          Case "#ERROR_UNKNOWN"
                               _error_text$(#ERROR_UNKNOWN)=_value$
                                   
                              Case "#ERROR_INIT_2D_GFX"
                             _error_text$(#ERROR_INIT_2D_GFX)=_value$
                         
                                 Case "#ERROR_INIT_3D_GFX"
                                 _error_text$(#ERROR_INIT_3D_GFX)=_value$
                                  
                                      Case "#ERROR_INIT_UI"
                                     _error_text$(#ERROR_INIT_UI)=_value$
                                            
                                        Case "#ERROR_INIT_IO"
                                       _error_text$(#ERROR_INIT_IO)=_value$
                                            
                                          Case "#ERROR_INIT_INIT"
                                         _error_text$(#ERROR_INIT_INIT)=_value$
                                         
                                              Case "#ERROR_OPEN_DEVELOPER_WINDOW"
                                               _error_text$(#ERROR_OPEN_DEVELOPER_WINDOW)=_value$
                                               
                                               Case "#ERROR_OPEN_WORLD_SCREEN"
                                               _error_text$(#ERROR_OPEN_WORLD_SCREEN)=_value$
                                               
                                               Case "#ERROR_INIT_SOUND"
                                                _error_text$(#ERROR_INIT_SOUND)=_value$
                                               
                                               Case "#ERROR_CREATE_CACHE"
                                               _error_text$(#ERROR_CREATE_CACHE)=_value$
                                               
                     EndSelect
                          
                
                Wend
        
        CloseFile(_ioID)
        
        Else
        
         __SHOW_ERROR(#ERROR_INIT_INIT)   ;will show an empty error requester because of missing info...text
  
        
        EndIf

EndProcedure

Procedure __INIT_CORE()


_ioID= ReadFile(#PB_Any,_core$+"ini.crc")

If _ioID<>0
        
                    While Not Eof(_ioID)
                      _key$=ReadString(_ioID)
                      _value$=ReadString(_ioID)
                    
                               Select _key$
                            
                                 Case "SYSTEMTEXT"
                                  _system_text_base$=_value$
                                      Case "ATOMSYSTEM"
                                      _atom$=_value$
                                        Case "GRIDSIZE"
                                         _grid_height=Val(_value$)
                                          _grid_width=Val(_value$)
                                          Case "MATRIXSIZE"
                                          _matrix_size.l=Val(_value$)
                                          If _matrix_size>_matrix_system_max.l
                                              _matrix_size=_matrix_system_max.l
                                          EndIf
                                          ;not used in this version (hardcoded at ENV)
                                            Case "MATRIX_OFFSET_X"
                                            _grid_offset_x=Val(_value$)
                                              Case "MATRIX_OFFSET_Y"
                                              _grid_offset_y=Val(_value$)
                                                                                           
                                              Case "USEDEBUGLOG"
                                              _use_debug_log.b=Val(_value$)
                                              
                                              Case "SCRSWITCHMS"
                                              _level_switch.l=Val(_value$)
                                              
                                              Case "BLOOM"
                                              _bloom.b=Val(_value$)
                                              
                                              Case "FRAMECOLLISION"
                                              _collision_check_type.b=Val(_value$)
                                              
                                              Case "CODECS"
                                              _codec_path$=_value$
                                              
                                              Case "GFX"
                                              _2dgfx_path$=_value$ 
                                              _2dgfx_path_backup$=_value$ 
                                              
                                              Case "EFFECT_GFX"
                                              
                                              _2d_effect_gfx_path.s=_value$
                                              
                                              Case "AREACOLLISION"
                                              _area_collision.b=Val(_value$)
                                              
                                              Case "MAXOBJECTS"
                                              _maxworldftile=Val(_value$)
                                              
                                              Case "COREBRAIN"
                                              _brain_skript.s=_value$
                                              
                                              Case "DEBUGLOG"
                                              _debug_path.s=_value$
                                              
                                              Case "SIMCORE"
                                              _level_path$=_value$
                                              
                                              Case "GLOBAL_GFX_FX"
                                              GLOBAL_GFX_FX.b=Val(_value$)
                                              
                                              Case "FONTFUNDAMENT"
                                              _fontFundament.s=_value$  
                                              
                                                                                           
                                               Case "FONT"
                                              _font.s=_value$  
                                              
                                              Case "SOURCEWIDTH"
                                              _defWidth=ValF(_value$)
                                             
                                              Case "ANIMSYSTEM"
                                              _anim_path$=_value$ ;the internal animpath for the engine 
                                              
                                              Case "MAXANIMFRAMES"
                                              _maxanimframes.l=Val(_value$)
                                              
                                              Case "SOURCEHEIGHT"
                                              _defHeight=ValF(_value$)
                                              
                                              Case "SOUNDPATH"
                                              _sound_path$=_value$
                                              
                                              Case "FILELOADMUSIC"
                                              _fileLoadMusicFile.s=_value$
                                              
                                              Case "LOADPIC"
                                              _loadScreen.b=Val(_value$)
                                              
                                              Case "GUI"
                                              _gui_path.s=_value$
                                              
                                              Case "IOPREFETCH"
                                              _doPrefetch.b=Val(_value$)
                                              
                                                                                          
                                              Case "ERRORPATH"
                                              _err_log$=_value$
                                              
                                              Case "WARNINGS"
                                              _warn_log$=_value$
                                              
                                              Case "USRSCROLL"
                                              _usr_scroll.b=Val(_value$)
                                              
                                              Case "VERSION"
                                              _ver$=_value$
                                              
                                              Case "DYNAMICSCROLL"
                                              _dynamic_scroll.b=Val(_value$)  ;0= no dynamic scrolling (controled by player character)
                                              
                                            Case "PIP"
                                            _pip.b=Val(_value$)
                                            
                                            
                                             Case "APPENTRY"
                                              _app_entry_point.l=Val(_value$)
                                              _gameLEVEL=_app_entry_point.l
                                            
                                            
                                            Case "APPMODE"
                                            _app_mode$=_value$
                                            
                                            
                                                          
                                            Select _app_mode$
                                            
                                                  Case "REGION"
                                                    _app_mode_.b=#REGION
                                                    
                                                  Case "MAP"
                                                  _app_mode_.b=#MAP
                                                  
                                                  Default
                                                  
                                                   _app_mode_.b=#REGION
                                                                                                                                            
                                            EndSelect
                                               
                                            
                                            Case "APPSMOOTH"
                                            _screen_smooth.b=Val(_value$)
                                             
                                             Case "MULTITASK" ;engine setting for multitask (0=off, >0 = EngineDelay(value)
                                             _multitask.b=Val(_value$)
                                             
                                             If _multitask.b>127
                                             _multitask.b=127
                                             EndIf
                                             
                                             If _multitask.b<0
                                             _multitask.b=0
                                             EndIf
                                             
                                             _multitask_backup.b=_multitask.b
                                            
                                             Case "PATH"
                                             _in_grid_settings.s=_value$
                                             
                                            
                                             Case "VSYNC"
                                              _vwait=Val(_value$)
                                              
                                              Case "MAXPLAYERS"
                                              _max_players.l=Val(_value$)
                                              
                                              Case "FULLSCREEN"
                                              _full_screen.f=ValF(_value$)
                                              
                                              Case "TEXTSMOOTH"
                                              _text_smooth.b=Val(_value$)
                                              
                                              Case "FUEL"
                                              _inventory(#fuel)\InventoryObjectSize=Val(_value$)
                                              _fuel_back_up=_inventory(#fuel)\InventoryObjectSize
                                                                                           
                                              Case "MAXFUEL"
                                              _max_fuel.b=Val(_value$)
                                              
                                              Case "CACHE"
                                              _cache_path.s=_value$
                                              
                                              Case "USECACHE"
                                              _use_cache.b=Val(_value$)
                                              
                                              Case "USELOADSCREEN"
                                              _load_screen_file=_value$
                                              
                                                                                            
                                              ;1=true
                                              ;<>1 = false
                           
                                             Case "TIMERBASE"
                                              _timer_base.l=Val(_Value$)
                                                                                         
                                                                              
                                  
                               EndSelect
                            
                    
                    Wend
                    CloseFile(_ioID)
                    __CODEC_PARSER(_codec_path$)
                    __SETTINGS_LOG( _in_grid_settings.s)
                   
                   
                   
        
              Else
              
          __SHOW_ERROR(#ERROR_INIT_INIT)  
        
        

EndIf



EndProcedure



; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 319
; FirstLine = 288
; Folding = --
; EnableXP
; EnableOnError
; CPU = 5
; SubSystem = DX9
; DisableDebugger