Declare __RESET_SIZE(value.l)
Declare __PLAY_ACTION_SOUND(_b.l,_c.b,_d.b)
Declare __SOUNDFX(value.l)
Declare __GET_EMITTEROBJECT_REGION(_obj.l,_src_h.f,_src_v.f)
Declare __GET_EMITTEROBJECT_MAP(_obj.l,_src_h.f,_src_v.f)




Procedure __DELETE_CACHE()
Define a.l,b.l=0

a.l=DeleteFile(_cache_path.s+"_") ;delete chache controller

For b.l=0 To 1000  ;1000levels?/Maps hardcoded for now
a.l=DeleteDirectory(_cache_path.s+Str(b.l),"") ;
Next
;check value a!
EndProcedure

Procedure  __CREATE_ACTUAL_CACHE(_actualLEVEL)
Define _cfile_open.l=0
Define _layer.l=24 
Define _destination.s=""
Define _ii.l=0
Define _l.l=0
_destination.s=_cache_path.s+Str(_actualLEVEL)



If _use_cache.b=1  ;is caching on?
;here we begin our cachingsystem: we store the last map-situation so we can do a "map over - location streaming":
;if you enter a building the building map will be loaded, if you exit the building (the same entrance you used)
;the map will be restored / reloaded showing the last situation bovore you entered the building
;if caching is not possible (storage..../free harddiskspace) engin will inform you about this situation.
;this will not be shown if caching is possible and/or caching is deactivated

    If CreateDirectory(_destination.s)  ;just try to create cache (level) directory
            
    EndIf  
    
         
 For _l.l=0 To _layer
          
             
     If CreateFile(_cfile_open.l,_destination.s+"\"+Str(_l.l))
     WriteStringN(_cfile_open.l,"0") ;dummy for the map xoffset
     WriteStringN(_cfile_open.l,"0") ;dummy for the map yoffset   
     
    For _ii.l=0 To _worldftile
             
            If _l.l=_3DGFXOBJECT(_ii.l)\FTileLayer  ;write 
               
             If _3DGFXOBJECT(_ii.l)\worldFTileRemove=0 ;1 = total removed from map, do not load it again (enemies allready killed and special for one time use)
             

               
               ;the "save place for the "player"
               If _3DGFXOBJECT(_ii.l)\worldFTileSaveY<>-1
               _3DGFXOBJECT(_ii.l)\worldFV=_3DGFXOBJECT(_ii.l)\worldFTileSaveY
               EndIf
               
               If _3DGFXOBJECT(_ii.l)\worldFTileSaveX<>-1
               _3DGFXOBJECT(_ii.l)\worldFH=_3DGFXOBJECT(_ii.l)\worldFTileSaveX
               EndIf
               ;end  
               
               WriteStringN(_cfile_open.l,"TILE") ;something valid?!?!?!  
               WriteStringN(_cfile_open.l,_3DGFXOBJECT(_ii.l)\worldFTileGFXFile)  ;gfxFilename/sourcefile
               WriteStringN(_cfile_open.l,"0");dummy for static id, which is not used/needed 
               WriteStringN(_cfile_open.l,Str(_3DGFXOBJECT(_ii.l)\worldFH))
               WriteStringN(_cfile_open.l,Str(_3DGFXOBJECT(_ii.l)\worldFV)) 
               WriteStringN(_cfile_open.l,Str(_3DGFXOBJECT(_ii.l)\worldFTileORIGW))
               WriteStringN(_cfile_open.l,Str(_3DGFXOBJECT(_ii.l)\worldFTileORIGH))  
               WriteStringN(_cfile_open.l,Str(_3DGFXOBJECT(_ii.l)\FTileLayer))  
               EndIf   
                 
                 
               EndIf
             
             
             
    Next  ;tiles...
    
    WriteStringN(_cfile_open.l,"ENGINETILEINFOEND")  
    
             
    CloseFile(_cfile_open.l)
  
             
             
             Else
             
                    
             __SHOW_ERROR(#ERROR_CREATE_CACHE)
             
             
     EndIf
     
     
       
    Next ;layer...
    

             

EndIf

If _cfile_open.l<>0
CloseFile(_cfile_open.l)  ;close it anyway..
EndIf
EndProcedure


Procedure __PLAYER_MANAGER(_PLAYER_ID,_b.l,_type$)
Define _a.l=0

Select _type$

Case "HP"

;anyway:
 _inventory(#alife)\InventoryObjectSize+_3DGFXOBJECT(_b.l)\hp

If _inventory(#alife)\InventoryObjectSize>_3DGFXOBJECT(_PLAYER_ID.l)\max_hp
   _inventory(#alife)\InventoryObjectSize=_3DGFXOBJECT(_PLAYER_ID.l)\max_hp
EndIf
_inventory(#alife)\InventoryObject=_inventory(#alife)\InventoryObject+"@"
_3DGFXOBJECT(_b.l)\worldFTileIsActive=-1 ;remove the firstaid (use  -1 to remove it from map )

Case "AMMO"

_inventory(#fuel)\InventoryObjectSize+_3DGFXOBJECT(_b.l)\hp
_3DGFXOBJECT(_b.l)\worldFTileIsActive=-1  ;remove it from map.
If _inventory(#fuel)\InventoryObjectSize>_max_fuel.b
_inventory(#fuel)\InventoryObjectSize=_max_fuel.b ;restore if value> default max
EndIf


Case "MONEY"
_inventory(#money)\InventoryObjectSize+_3DGFXOBJECT(_b.l)\hp  ;just store the ammount of money....
_3DGFXOBJECT(_b.l)\worldFTileIsActive=-1

EndSelect

__SETUP_INVENTORY()



EndProcedure




Procedure __ELIMINATE_MEDIA(_d)
Define _fra.l=0
;this routine is a part/develope /experimental beginning of a streaming system: here we kill the media out of memory! 
;it is used for single life objects
;here we kill one object only!!!!!
;kill sounddata :


If _3DGFXOBJECT(_d.l)\animContainer<>""
If IsSound(_3DGFXOBJECT(_d.l)\worldFTileSoundIndex)
    StopSound(_3DGFXOBJECT(_d.l)\worldFTileSoundIndex)
    FreeSound(_3DGFXOBJECT(_d.l)\worldFTileSoundIndex)
  _3DGFXOBJECT(_d.l)\worldFTileIsSound=#False
  _3DGFXOBJECT(_d.l)\worldFTileSoundIsPlaying=#False

EndIf

If IsSprite3D(_3DGFXOBJECT(_d.l)\worldFTileGFX)
   FreeSprite3D(_3DGFXOBJECT(_d.l)\worldFTileGFX)
EndIf




;free the graphics memory used by the object:

              ;kill the frames:
              For _fra.l=1 To 32  ;max frames (hardcoded)
              
              
      
               If IsSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameDEFAULT[_fra.l])
               FreeSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameDEFAULT[_fra.l])
              EndIf ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
              
              If IsSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameDEFAULT[_fra.l])
                     FreeSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameDEFAULT[_fra.l])
              EndIf ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
               
               If IsSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameR[_fra.l])
                  FreeSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameR[_fra.l])
               EndIf ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
                ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
               
                   If IsSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameR[_fra.l])
                   FreeSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameR[_fra.l])
                   EndIf
                
               If IsSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameL[_fra.l])
                  FreeSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameL[_fra.l])
              
               EndIf ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
               
                    If IsSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameL[_fra.l])
                      FreeSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameL[_fra.l])
                   EndIf ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
                
               If IsSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameU[_fra.l])
                  FreeSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameU[_fra.l])
             
               EndIf ;th
                     
               If IsSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameU[_fra.l])
                  FreeSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameU[_fra.l])
               EndIf ;th
              
               
              If IsSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameD[_fra.l])
                  FreeSprite3D(_3DGFXOBJECT(_d)\worldFTileAnimFrameD[_fra.l])
              EndIf ;th  
              
                    
               
              If IsSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameD[_fra.l])
                  FreeSprite(_3DGFXOBJECT(_d)\worldFTileAnim2DFrameD[_fra.l])
              EndIf ;th  
               
                       
              Next
  EndIf  ;deleted animcontainer  



EndProcedure



Procedure __TOUCHMOVE(_a.l,_b.l)

If _3DGFXOBJECT(_a.l)\worldFTileWeight>_3DGFXOBJECT(_b.l)\worldFTileWeight
_3DGFXOBJECT(_b.l)\worldFTileMoveV=_3DGFXOBJECT(_a.l)\worldFTileMoveV
_3DGFXOBJECT(_b.l)\worldFTileVeloV=_3DGFXOBJECT(_a.l)\worldFTileVELO
_3DGFXOBJECT(_b.l)\worldFTileMoveH=_3DGFXOBJECT(_a.l)\worldFTileMoveH
_3DGFXOBJECT(_b.l)\worldFTileVeloH=_3DGFXOBJECT(_a.l)\worldFTileVELO
_3DGFXOBJECT(_b.l)\worldFTileVELO=_3DGFXOBJECT(_a.l)\worldFTileVELO
EndIf

EndProcedure




Procedure  __SCORE_MANAGER(_a.l,_b.l)
;use origin HP of defeadsed object as score to add
_3DGFXOBJECT(_PLAYER_ID)\playerSCORE+_3DGFXOBJECT(_b.l)\max_hp  ;single player code for now...
_player_score.l=_3DGFXOBJECT(_PLAYER_ID)\playerSCORE
;  If IsSound(#SCORESOUND)
;  PlaySound(#SCORESOUND)
;  EndIf
EndProcedure

Procedure __HP_MANAGER(_a.l,_b.l)
Define _le.b=1

    
   If _3DGFXOBJECT(_b.l)\worldFTilePlayerID<>0
   
   _3DGFXOBJECT(_b.l)\hp-_3DGFXOBJECT(_a.l)\weaponPower
   
   _inventory(#alife)\InventoryObjectSize-_3DGFXOBJECT(_a.l)\weaponPower
   
    
    If _inventory(#alife)\InventoryObjectSize<1
              _gameOver=#True   ;the gameoverlayer
     ProcedureReturn  ;exit...player is dead!
     
     Else
     __SETUP_INVENTORY()
     ProcedureReturn  ;exit...got one more chance...
     
   EndIf
    
  EndIf
  
 

   
   
   If _3DGFXOBJECT(_b.l)\worldFTilePlayerID=0 
   
   _3DGFXOBJECT(_b.l)\hp-_3DGFXOBJECT(_a.l)\weaponPower
   
   If _3DGFXOBJECT(_b.l)\hp<1
   
    
   ;special for killed objects
    Select _3DGFXOBJECT(_b.l)\worldFTileIDString
    
        Case "DEFAULTZOMBIE"
        
        
;                
;              _3DGFXOBJECT(_b.l)\worldFTileRemove=1  ;killed!!!
;              _3DGFXOBJECT(_b.l)\worldFTileIsActive=-1
;              If _3DGFXOBJECT(_b.l)\worldFTileIsAnim=1
;             ; __ELIMINATE_MEDIA(_b.l)
;              EndIf
;              __SCORE_MANAGER(_a.l,_b.l)
;              _3DGFXOBJECT(_b.l)\hp=0  ; give it a valid state
           
             
             
                Select Random(5)
                
                 Case 0
                _3DGFXOBJECT(_b.l)\useWeapon="MONEY"
                 __GET_EMITTEROBJECT_MAP(_b,_3DGFXOBJECT(_b)\worldFH,_3DGFXOBJECT(_b)\worldFV)
                
                Case 1
                _3DGFXOBJECT(_b.l)\useWeapon="HP+"
                __GET_EMITTEROBJECT_MAP(_b,_3DGFXOBJECT(_b)\worldFH,_3DGFXOBJECT(_b)\worldFV)
                
                Default 
                _3DGFXOBJECT(_b.l)\useWeapon="BURNEDZOMBIE"
                 __GET_EMITTEROBJECT_MAP(_b,_3DGFXOBJECT(_b)\worldFH,_3DGFXOBJECT(_b)\worldFV)
                EndSelect
                
                      
             _3DGFXOBJECT(_b.l)\worldFTileRemove=1  ;killed!!!
             _3DGFXOBJECT(_b.l)\worldFTileIsActive=0
             __SCORE_MANAGER(_a.l,_b.l)
             __ELIMINATE_MEDIA(_b.l)
             _3DGFXOBJECT(_b.l)\hp=0  ; give it a valid state             
             __PLAY_ACTION_SOUND(_b.l,1,1)  
                
                
                
          Case "CRAPS"
          
                                
                Select Random(5)
                
                 Case 0
                _3DGFXOBJECT(_b.l)\useWeapon="MONEY"
                  __GET_EMITTEROBJECT_MAP(_b,_3DGFXOBJECT(_b)\worldFH,_3DGFXOBJECT(_b)\worldFV)
                __PLAY_ACTION_SOUND(_b.l,1,1)
                Case 1
                _3DGFXOBJECT(_b.l)\useWeapon="HP+"
                  __GET_EMITTEROBJECT_MAP(_b,_3DGFXOBJECT(_b)\worldFH,_3DGFXOBJECT(_b)\worldFV)
                __PLAY_ACTION_SOUND(_b.l,1,1)
                Default 
             
                EndSelect
                
                
                
             _3DGFXOBJECT(_b.l)\worldFTileRemove=1  ;killed!!!
             _3DGFXOBJECT(_b.l)\worldFTileIsActive=0
             __SCORE_MANAGER(_a.l,_b.l)
             __ELIMINATE_MEDIA(_b.l)
             _3DGFXOBJECT(_b.l)\hp=0  ; give it a valid state             
             __PLAY_ACTION_SOUND(_b.l,1,1)  
                               
             
             
                   
          Case "REDVIRUS"
        
              Select Random(5)
                
                 Case 0
                _3DGFXOBJECT(_b.l)\useWeapon="MONEY"
                  __GET_EMITTEROBJECT_MAP(_b.l,_3DGFXOBJECT(_b.l)\worldFH,_3DGFXOBJECT(_b.l)\worldFV)
                __PLAY_ACTION_SOUND(_b.l,1,1)
                Case 1
                _3DGFXOBJECT(_b.l)\useWeapon="HP+"
                  __GET_EMITTEROBJECT_MAP(_b.l,_3DGFXOBJECT(_b.l)\worldFH,_3DGFXOBJECT(_b.l)\worldFV)
                __PLAY_ACTION_SOUND(_b.l,1,1)
                Default 
             
                EndSelect 
                
                
            ;_3DGFXOBJECT(_b.l)\worldFTileRemove=1  ;killed!!!
            _3DGFXOBJECT(_b.l)\worldFTileIsActive=0
             __SCORE_MANAGER(_a.l,_b.l)
            ; __ELIMINATE_MEDIA(_b.l)
             _3DGFXOBJECT(_b.l)\hp=0  ; give it a valid state    
             
             
             
                       
          Case "BASEWANZE"
          
              
             _3DGFXOBJECT(_b.l)\worldFTileRemove=1  ;killed!!!
             _3DGFXOBJECT(_b.l)\worldFTileIsActive=0
             __SCORE_MANAGER(_a.l,_b.l)
             __ELIMINATE_MEDIA(_b.l)
             _3DGFXOBJECT(_b.l)\hp=0  ; give it a valid state             
             __PLAY_ACTION_SOUND(_b.l,1,1)  
        
               Select Random(5)
                
                 Case 0
                _3DGFXOBJECT(_b.l)\useWeapon="MONEY"
                  __GET_EMITTEROBJECT_MAP(_b.l,_3DGFXOBJECT(_b.l)\worldFH,_3DGFXOBJECT(_b.l)\worldFV)
                __PLAY_ACTION_SOUND(_b.l,1,1)
                Case 1
                _3DGFXOBJECT(_b.l)\useWeapon="HP+"
                  __GET_EMITTEROBJECT_MAP(_b.l,_3DGFXOBJECT(_b.l)\worldFH,_3DGFXOBJECT(_b.l)\worldFV)
                __PLAY_ACTION_SOUND(_b.l,1,1)
                Default 
             
               EndSelect     
               
               
               
               
               
                            
          Case "EXPLOSIVEFASS"
          
              
             _3DGFXOBJECT(_b.l)\worldFTileRemove=1  ;killed!!!
             _3DGFXOBJECT(_b.l)\worldFTileIsActive=0
             __ELIMINATE_MEDIA(_b.l)
             _3DGFXOBJECT(_b.l)\hp=0  ; give it a valid state             
             __PLAY_ACTION_SOUND(_b.l,1,1)  
                  
          
 
           
   Default
       
       
;        
;      _3DGFXOBJECT(_b.l)\worldFTileIsActive=-1  ;killed!!!
; ;      If _3DGFXOBJECT(_b.l)\worldFTileIsAnim=1
;      __ELIMINATE_MEDIA(_b.l)
; ;      EndIf
;      __SCORE_MANAGER(_a.l,_b.l)
;      _3DGFXOBJECT(_b.l)\hp=0  ; give it a valid state
    
   EndSelect
   
   
   EndIf
   EndIf

     

EndProcedure



Procedure __EXIT_UP(_actualLEVEL)


Select _actualLEVEL

Case 3

_gameLEVEL=1 

Case 4

_gameLEVEL=2

Case 8

_gameLEVEL=9

Case 9
_gameLEVEL=10

Case 12

_gameLEVEL=11

Case 13

_gameLEVEL=14



EndSelect



EndProcedure

Procedure __EXIT_DOWN(_actualLEVEL)



Select _actualLEVEL


Case 1
_gameLEVEL=3

Case 2
_gameLEVEL=4

Case 5
_gameLEVEL=6

Case 4
_gameLEVEL=8

Case 10

_gameLEVEL=9

Case 11

_gameLEVEL=12

Case 14

_gameLEVEL=13



EndSelect


EndProcedure


Procedure __EXIT_LEFT(_actualLEVEL)


Select _actualLEVEL

Case 2

_gameLEVEL=1

Case 1

_gameLEVEL=0

Case 3
_gameLEVEL=5

Case 8

_gameLEVEL=7

Case 13

_gameLEVEL=12



EndSelect


EndProcedure


Procedure __EXIT_RIGHT(_actualLEVEL)


Select _actualLEVEL


Case 0
_gameLEVEL=1

Case 1

_gameLEVEL=2


Case 3

_gameLEVEL=4

Case 4

_gameLEVEL=3

Case 5

_gameLEVEL=3

Case 6

_gameLEVEL=7

Case 7

_gameLEVEL=8


Case 8

_gameLEVEL=9

Case 12

_gameLEVEL=13

Case 10

_gameLEVEL=4096  ;gameover just to make it ....






EndSelect


EndProcedure








Procedure __STORYBOARD(_actualLEVEL,_exit_stage$)
Define _level.l
;here we switch the level if we go to an exitpoint

If _use_cache<>0
__CREATE_ACTUAL_CACHE(_actualLEVEL) ;create it if cache is "on" used for sandbox/openworld maps, so we can use "smaller" locations and exits : building/streets/rooms...

_level.l=CreateFile(#PB_Any,_cache_path.s+"_")

If _level.l<>0

WriteString(_level.l,Str(_actualLEVEL))

CloseFile(_level.l)
EndIf

EndIf



Select _exit_stage$

Case "EXIT_UP"


__EXIT_UP(_actualLEVEL)

Case "EXIT_DOWN"


__EXIT_DOWN(_actualLEVEL)

Case "EXIT_LEFT"


__EXIT_LEFT(_actualLEVEL)

Case "EXIT_RIGHT"

__EXIT_RIGHT(_actualLEVEL)



EndSelect


EndProcedure


Procedure __PLAY_ACTION_SOUND(_b.l,_mx.b,_my.b)

If _3DGFXOBJECT(_b.l)\worldFTileSoundPlayOnAction<>0
;use _mx or  _my as controll value (char moved, object moved, char / object  hit key ....)
If _mx<>0 Or _my<>0
;object:sound? play it for visible objects only
__SOUNDFX(_b)
EndIf

EndIf

EndProcedure





Procedure AUTOMOVE_GOODIES(_a.l,_b.l)
;for some special items which "fly" to playerobject as: HP, Money...
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1

EndProcedure

Procedure FLAMME(_a.l,_b.l)


Select  _3DGFXOBJECT(_b.l)\worldFTileIDString

Case "NOGO" 
;flames do not stop on default objects :-)
; _3DGFXOBJECT(_a.l)\goONX=1
; _3DGFXOBJECT(_a.l)\goONY=1



Default
;flames do not stop on default objects :-)
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1


EndSelect


EndProcedure



Procedure DEFAULTBULLET(_a.l,_b.l)


Select  _3DGFXOBJECT(_b.l)\worldFTileIDString

Case "NOGO" ,"SECUDOOR"
_3DGFXOBJECT(_a.l)\worldFTileIsActive=0

Case "DEFAULTZOMBIE","BASEWANZE","CRAPS","REDVIRUS";big enemy....

__HP_MANAGER(_a.l,_b.l)
_3DGFXOBJECT(_a.l)\worldFTileIsActive=0;remove bullet!!! 
_3DGFXOBJECT(_b.l)\useWeapon="FUNKE"
_3DGFXOBJECT(_b.l)\worldFTileRandomActivateWeapon=0



Case "EXPLOSIVEFASS","GASTANK"

__HP_MANAGER(_a.l,_b.l)
_3DGFXOBJECT(_a.l)\worldFTileIsActive=0;remove bullet!!! 
If Random(50)=0
_3DGFXOBJECT(_b.l)\useWeapon="FUNKE"
_3DGFXOBJECT(_b.l)\worldFTileRandomActivateWeapon=0
EndIf

Default
;flames do not stop on default objects :-)
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1


EndSelect


If _3DGFXOBJECT(_a.l)\worldFTileIsActive=0
 __RESET_SIZE(_a.l)

EndIf


EndProcedure


Procedure ACID(_a.l,_b.l)


Select  _3DGFXOBJECT(_b.l)\worldFTileIDString

Case "NOGO" ,"SECUDOOR"
;NOPE
Default
;flames do not stop on default objects :-)

If _3DGFXOBJECT(_b.l)\worldfTilePlayerID<>0
If _3DGFXOBJECT(_b.l)\hp>0
__HP_MANAGER(_a.l,_b.l)

EndIf
EndIf

_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1


EndSelect


EndProcedure




Procedure PLAYER(_a.l,_b.l)

Define _c.l ;counter
Define _fio.l=0 ;fileopen...

_3DGFXOBJECT(_a.l)\worldFTileSaveX=-1
_3DGFXOBJECT(_a.l)\worldFTileSaveY=-1

;--------------------------------

Select  _3DGFXOBJECT(_b.l)\worldFTileIDString

Case "NOGO" ,"STUHL","FASS","BACK" ;default stopp-object  (wall,etc)
;__REFRAME(_a.l) 



Case "REDVIRUS","LICHMINI","FUNKE","BASKET","HELMET","WALKRIGHT","WALKLEFT","WALKUP","WALKDOWN","BASEWANZE";big ennemy must place action code for fight...
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1


Case "METALLGITTER" ,"DEFAULTBULLET","BODEN","WANZE","FLAMME","TRANSVEGI","GREENPLANT"
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1


Case "GREENACID"
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1 
_3DGFXOBJECT(_a.l)\worldFTileSaveX=-1
_3DGFXOBJECT(_a.l)\worldFTileSaveY=-1
;__HP_MANAGER(_a.l,_b.l)


Case "LAUB"
If _3DGFXOBJECT(_a.l)\worldFTileMoveH<>0 Or _3DGFXOBJECT(_a.l)\worldFTileMoveV<>0 
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1 
_3DGFXOBJECT(_b.l)\useWeapon="LAUBBLATT"
_3DGFXOBJECT(_b.l)\worldFTileRandomActivateWeapon=100
_3DGFXOBJECT(_a.l)\worldFTileSaveX=-1
_3DGFXOBJECT(_a.l)\worldFTileSaveY=-1

EndIf

;__HP_MANAGER(_a.l,_b.l)


Case "EXTRAFUEL"
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
_3DGFXOBJECT(_a.l)\worldFTileSaveX=-1
_3DGFXOBJECT(_a.l)\worldFTileSaveY=-1
__PLAYER_MANAGER(_a.l,_b.l,"AMMO")




Case "FIRSTAID","HP+"
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
_3DGFXOBJECT(_a.l)\worldFTileSaveX=-1
_3DGFXOBJECT(_a.l)\worldFTileSaveY=-1
__PLAYER_MANAGER(_a.l,_b.l,"HP")


Case "MONEY"
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
_3DGFXOBJECT(_a.l)\worldFTileSaveX=-1
_3DGFXOBJECT(_a.l)\worldFTileSaveY=-1
__PLAYER_MANAGER(_a.l,_b.l,"MONEY")






Case "NEWGAME"
If _actualLEVEL=1000
   _gameLEVEL=999 ;start the game!
;put here the code for the cache cleaning...
Else
;level = 999 
__DELETE_CACHE()
_gameLEVEL=0
EndIf


Case "CONTINUE"
If _actualLEVEL=1000
_gameLEVEL=999
Else
_fio.l=ReadFile(#PB_Any, _cache_path.s+"_")
If _fio.l<>0
_gameLEVEL=Val(ReadString(_fio.l))
CloseFile(_fio.l)
Else
_gameLEVEL=0  ;will use cache if activated and start with the last used map...
EndIf

EndIf

Case "EXITGAME"

If _actualLEVEL=1000 Or _actualLEVEL<900
_gameLEVEL=999
Else
_gameLEVEL=4095
EndIf

Case "BRUECKE"

; _3DGFXOBJECT(_b.l)\worldFTileFLire=5
; _3DGFXOBJECT(_b.l)\worldFTileinGameLiveTimeCounter=1
; _3DGFXOBJECT(_b.l)\worldFTileinGameActualLiveTime=0
; _3DGFXOBJECT(_b.l)\worldFTileinGameLiveTime=2
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1

Case "IDCARD"

_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
__PLAY_ACTION_SOUND(_b.l,_3DGFXOBJECT(_a.l)\worldFTileMoveH,_3DGFXOBJECT(_a.l)\worldFTileMoveV)
_3DGFXOBJECT(_b.l)\worldFTileIsActive=-1 ;remove this IDCARD from map
_inventory(#idcard)\InventoryObject=_inventory(#idcard)\InventoryObject+""
_inventory(#idcard)\InventoryObjectSize+1
ProcedureReturn


; ; For _c.l=0 To 126  ;find free inventory  (for now we do not use limit < 127)
; If _inventory(_c.l)\InventoryObject=""
;    _inventory(_c.l)\InventoryObject=_3DGFXOBJECT(_b.l)\worldFTileIDString
;   ProcedureReturn ;we jump out of the for/next but we have to go for the end of the procedure because of the action-sound check...
; EndIf
; Next






;put IDCRAD CODE here (player gets idcard and can open gate/door):


Case "SECUDOOR"

;special for player objects (controled by human or computer...)
    
     If _inventory(#idcard)\InventoryObjectSize>0
         __PLAY_ACTION_SOUND(_b.l,1,1)
        _3DGFXOBJECT(_b.l)\worldFTileIsActive=-1 ;simple remove door for now, put interesting action instead of this  in later version
        _3DGFXOBJECT(_b.l)\worldFTileCollision=0
        _inventory(#idcard)\InventoryObjectSize-1
        _inventory(#idcard)\InventoryObject=RSet(_inventory(#idcard)\InventoryObject,_inventory(#idcard)\InventoryObjectSize)
    EndIf 

   
   
   Case "SAVESTART"
;used for the player last save position because of the enter/exit room streaming
;we prevent map looping in case of "exit" collision and simultan saving the player position on top of the exit object
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
;If _3DGFXOBJECT(_a.l)\worldFTileSaveX=-1 And _3DGFXOBJECT(_a.l)\worldFTileSaveY=-1  ;store the first contact!!!!
_3DGFXOBJECT(_a.l)\worldFTileSaveX=_3DGFXOBJECT(_a.l)\worldFH
_3DGFXOBJECT(_a.l)\worldFTileSaveY=_3DGFXOBJECT(_a.l)\worldFV
;EndIf 



Case "EXIT_LEFT","EXIT_RIGHT","EXIT_UP","EXIT_DOWN"
__STORYBOARD(_actualLEVEL,_3DGFXOBJECT(_b.l)\worldFTileIDString)


Default
;for developement...:

EndSelect

__PLAY_ACTION_SOUND(_b.l,_3DGFXOBJECT(_a.l)\worldFTileMoveH,_3DGFXOBJECT(_a.l)\worldFTileMoveV)

EndProcedure





Procedure CRAPS(_a.l,_b.l)

If _3DGFXOBJECT(_b.l)\worldFTilePlayerID<>0  ;solution for playerobject, so we do not need to take care of object names
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
EndIf

Select  _3DGFXOBJECT(_b.l)\worldFTileIDString
    Case "NOGO","BACK"  ;default stopp-object  (wall,etc)
    __AI_CORE(_a.l,_b.l) 
     
Case "BODEN","LAUB","IDCARD","TRANSVEGI","METALLGITTER","DEFAULTZOMBIE","BRUECKE","REDVIRUS","MONEY","HP+"
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1



Case "FLAMME","DEFAULTBULLET" ;some spooky effect (just for fun) and to demonstrate the engine *g*

_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
_3DGFXOBJECT(_a.l)\useWeapon="FUNKE"

;-------------

Default

      If _3DGFXOBJECT(_b.l)\worldfTilePlayerID<>0
      If _3DGFXOBJECT(_b.l)\hp>0
      __HP_MANAGER(_a.l,_b.l)
      EndIf
      EndIf

     
EndSelect

 ;call the intelligence... :)

EndProcedure



Procedure HELMET(_a.l,_b.l)

If _3DGFXOBJECT(_b.l)\worldFTilePlayerID<>0  ;solution for playerobject, so we do not need to take care of object names
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
EndIf

Select  _3DGFXOBJECT(_b.l)\worldFTileIDString
    Case "NOGO"  ;default stopp-object  (wall,etc)
   ; __REFRAME(_a.l) 
     _3DGFXOBJECT(_a.l)\worldFTileMoveV*-1
     _3DGFXOBJECT(_a.l)\worldFTileMoveH*-1
     
Case "BODEN","WANZE","LAUB","IDCARD","TRANSVEGI","METALLGITTER","DEFAULTZOMBIE","GREENPLANT"
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1

     
EndSelect

__AI_CORE(_a.l,_b.l)  ;call the intelligence... :)

EndProcedure


Procedure DEKO(_a.l,_b.l)

If _3DGFXOBJECT(_b.l)\worldFTilePlayerID<>0  ;solution for playerobject, so we do not need to take care of object names
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
EndIf

Select  _3DGFXOBJECT(_b.l)\worldFTileIDString
    Case "NOGO"  ;default stopp-object  (wall,etc)
   ; __REFRAME(_a.l) 
     _3DGFXOBJECT(_a.l)\worldFTileMoveV*-1
     _3DGFXOBJECT(_a.l)\worldFTileMoveH*-1
     
Default
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1
     
EndSelect

__AI_CORE(_a.l,_b.l)  ;call the intelligence... :)

EndProcedure





Procedure BASKET(_a.l,_b.l)


Select  _3DGFXOBJECT(_b.l)\worldFTileIDString
    Case "NOGO"  ;default stopp-object  (wall,etc)
  
   
     _3DGFXOBJECT(_a.l)\worldFTileMoveV*-1
     _3DGFXOBJECT(_a.l)\worldFTileMoveH*-1
       
 
Default
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1


     
EndSelect

__AI_CORE(_a.l,_b.l)  ;call the intelligence... :)


EndProcedure






Procedure BASEWANZE(_a.l,_b.l)




   Select  _3DGFXOBJECT(_b.l)\worldFTileIDString
      
      Case "NOGO","TROOPER" ,"BACK" ;default stopp-object  (wall,etc)
     __AI_CORE(_a.l,_b.l)  ;call the intelligence... :)
         
      Case "DEFAULTZOMBIE","BASEWANZE"
      __AI_CORE(_a.l,_b.l)  ;call the intelligence... :)
     
         
     ;here we do some spectaculr!!!!
     
     If _3DGFXOBJECT(_a.l)\useWeapon="FUNKE"
        _3DGFXOBJECT(_b.l)\useWeapon="FUNKE"  ;burn baby burn!!!!!
     EndIf  

      
      Case "DEFAULTBULLET"
        _3DGFXOBJECT(_a.l)\useWeapon="FUNKE"  ;burn baby burn!!!!!
        
      
      
      Case "BODEN","WANZE","LAUB","IDCARD","LAUB","FUNKE","GREENPLANT","BRUECKE","REDVIRUS","MONEY","HP+"
      _3DGFXOBJECT(_a.l)\goONX=1
      _3DGFXOBJECT(_a.l)\goONY=1
     
      
              
      Default
    _3DGFXOBJECT(_a.l)\goONX=1
    _3DGFXOBJECT(_a.l)\goONY=1
           
  EndSelect

 __PLAY_ACTION_SOUND(_b.l,_3DGFXOBJECT(_a.l)\worldFTileMoveH,_3DGFXOBJECT(_a.l)\worldFTileMoveV)


EndProcedure




Procedure DEFAULTZOMBIE(_a.l,_b.l)




   Select  _3DGFXOBJECT(_b.l)\worldFTileIDString
      
      Case "NOGO","BACK" ;default stopp-object  (wall,etc)
     __AI_CORE(_a.l,_b.l)  ;call the intelligence... :)
         
      Case "DEFAULTZOMBIE"
      __AI_CORE(_a.l,_b.l)  ;call the intelligence... :)
     
         
     ;here we do some spectaculr!!!!
     
     If _3DGFXOBJECT(_a.l)\useWeapon="FUNKE"
        _3DGFXOBJECT(_b.l)\useWeapon="FUNKE"  ;burn baby burn!!!!!
     EndIf   
      
      Case "DEFAULTBULLET"
        _3DGFXOBJECT(_a.l)\useWeapon="FUNKE"  ;burn baby burn!!!!!
        
      
      
      Case "BODEN","WANZE","IDCARD","LAUB","FUNKE","GREENPLANT","BRUECKE","REDVIRUS","MONEY","HP+"
      _3DGFXOBJECT(_a.l)\goONX=1
      _3DGFXOBJECT(_a.l)\goONY=1
     
     Case "LAUB"
        If _3DGFXOBJECT(_a.l)\worldFTileMoveH<>0 Or _3DGFXOBJECT(_a.l)\worldFTileMoveV<>0 
        _3DGFXOBJECT(_a.l)\goONX=1
        _3DGFXOBJECT(_a.l)\goONY=1 
        _3DGFXOBJECT(_b.l)\useWeapon="LAUBBLATT"
        _3DGFXOBJECT(_b.l)\worldFTileRandomActivateWeapon=100
        
        EndIf
      
              
      Default
    _3DGFXOBJECT(_a.l)\goONX=1
    _3DGFXOBJECT(_a.l)\goONY=1
    
      If _3DGFXOBJECT(_b.l)\worldfTilePlayerID<>0
      If _3DGFXOBJECT(_b.l)\hp>0
      __HP_MANAGER(_a.l,_b.l)
      EndIf
      EndIf
           
  EndSelect

 __PLAY_ACTION_SOUND(_b.l,_3DGFXOBJECT(_a.l)\worldFTileMoveH,_3DGFXOBJECT(_a.l)\worldFTileMoveV)


EndProcedure




Procedure FUNKE(_a.l,_b.l)
_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1

Select _3DGFXOBJECT(_b.l)\worldFTileIDString

Case "NOGO"

_3DGFXOBJECT(_a.l)\goONX=0
_3DGFXOBJECT(_a.l)\goONY=0

Case "DEFAULTZOMBIE","BASEWANZE","CRAPS","EXPLOSIVEFASS","GASTANK";place here all objects you want to kill using "funke"
    _3DGFXOBJECT(_b.l)\useWeapon="FUNKE"
    __HP_MANAGER(_a.l,_b.l)
  
    
EndSelect


EndProcedure




Procedure REDVIRUS(_a.l,_b.l)


Select  _3DGFXOBJECT(_b.l)\worldFTileIDString

Case "NOGO" ,"SECUDOOR"
;NOPE
Default
;flames do not stop on default objects :-)

If _3DGFXOBJECT(_b.l)\worldfTilePlayerID<>0
If _3DGFXOBJECT(_b.l)\hp>0
__HP_MANAGER(_a.l,_b.l)
EndIf
EndIf

_3DGFXOBJECT(_a.l)\goONX=1
_3DGFXOBJECT(_a.l)\goONY=1

EndSelect


EndProcedure






Procedure TRANSPORT(_a.l,_b.l)

 Select _3DGFXOBJECT(_b.l)\worldFTIleIDString
              
              Case "WALKDOWN"
              
              _3DGFXOBJECT(_a.l)\goONX=0
              _3DGFXOBJECT(_a.l)\goONY=1
              _3DGFXOBJECT(_a.l)\worldFTileMoveV=1
              
              Case "WALKUP"
              _3DGFXOBJECT(_a.l)\goONX=0
              _3DGFXOBJECT(_a.l)\goONY=1
              _3DGFXOBJECT(_a.l)\worldFTileMoveV=-1
              
              Case "WALKLEFT"
        
              _3DGFXOBJECT(_a.l)\goONX=1
              _3DGFXOBJECT(_a.l)\goONY=0
              _3DGFXOBJECT(_a.l)\worldFTileMoveH=-1
              
              Case "WALKRIGHT"
         
              _3DGFXOBJECT(_a.l)\goONX=1
              _3DGFXOBJECT(_a.l)\goONY=0
              _3DGFXOBJECT(_a.l)\worldFTileMoveH=1
                    
    
        EndSelect


EndProcedure


Procedure GREENPLANT(_a.l,_b.l)

Select _3DGFXOBJECT(_b.l)\worldFTIleIDString
              
              Case "NOGO"
              
              _3DGFXOBJECT(_a.l)\goONX=0
              _3DGFXOBJECT(_a.l)\goONY=0
              
              
              Default 
              
              _3DGFXOBJECT(_a.l)\goONX=1
              _3DGFXOBJECT(_a.l)\goONY=1
                         
    
        EndSelect




EndProcedure


Procedure REDFIRE(_a.l,_b.l)


Select _3DGFXOBJECT(_b.l)\worldFTIleIDString
              
              Case "NOGO"
              
              _3DGFXOBJECT(_a.l)\goONX=0
              _3DGFXOBJECT(_a.l)\goONY=0
              
              
              Default 
              
              _3DGFXOBJECT(_a.l)\goONX=1
              _3DGFXOBJECT(_a.l)\goONY=1
                         
    
        EndSelect



EndProcedure
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 612
; FirstLine = 585
; Folding = -----
; EnableXP
; EnableOnError
; Executable = doe.exe
; CPU = 5
; SubSystem = DX9
; DisableDebugger