UsePNGImageDecoder()
UseJPEGImageDecoder()
UseOGGSoundDecoder()
UseTGAImageDecoder()
UseTIFFImageDecoder()

;----CONSTANTS

   #D3DBLEND_ZERO            = 1
   #D3DBLEND_ONE             = 2
   #D3DBLEND_SRCCOLOR        = 3
   #D3DBLEND_INVSRCCOLOR     = 4
   #D3DBLEND_SRCALPHA        = 5
   #D3DBLEND_INVSRCALPHA     = 6
   #D3DBLEND_DESTALPHA       = 7
   #D3DBLEND_INVDESTALPHA    = 8
   #D3DBLEND_DESTCOLOR       = 9
   #D3DBLEND_INVDESTCOLOR    = 10
   #D3DBLEND_SRCALPHASAT     = 11
   #D3DBLEND_BOTHSRCALPHA    = 12
   #D3DBLEND_BOTHINVSRCALPHA = 13
   
   
   
   
Enumeration
 #ERROR_UNKNOWN
 #ERROR_INIT_IO
 #ERROR_INIT_2D_GFX
 #ERROR_INIT_3D_GFX 
 #ERROR_INIT_UI
 #ERROR_INIT_SOUND
 #ERROR_INIT_INIT
 #ERROR_OPEN_DEVELOPER_WINDOW
 #ERROR_OPEN_WORLD_SCREEN
 #ERROR_CREATE_CACHE
 #MOUSE
 #KEYBOARD 
 #STICK 
 #TOUCH 
 #MULTICONTROL 
 #REGION
 #MAP
 #FOLLOW
 #FLEE
 #ATTACK
 ;special effects /blittersystem for screenmanipulation
 #AREAFADEOUT
 #AREAFADEIN
 #SWITCHCUBUS
 #AREAFADEOUTLOOP
 #AREAFADEINLOOP
 #HORIZONTAL_MOVE
 #VERTICAL_MOVE
 #MOVE_UP   ;for internal use  (anim frame system version 191211)
 #MOVE_DOWN
 #MOVE_LEFT 
 #MOVE_RIGHT 
 #SCORESOUND
 #MOVE_DEFAULT
 #INIT
 #SHOW
 EndEnumeration 

 



;--
Global _mode.l=0
Global _reset_fade_in.b=1
Global _init_special_screen.b=0
Global _no_mirror.b=0 ;switch mirror effect on/off...for performance issues
Global _app_mode$="REGION" ;default
Global _app_mode_.b=#REGION ;default
Global _ver$="VERSION INFO MISSING"
Global _usr_scroll.b=0
Global _dx1.b=0
Global _dx2.b=0
;Global _gridIsScaled=0  ;workaround for the scaler to scale _grid only one time! (1=allready scaled!!!!)
Global _scale=0
Global _level_path$=""
Global _maxworldftile=0
Global _error_code.b=0
Global Dim _error_text$(10)
Global _core$=GetCurrentDirectory()+"\CORE\"
Global _mywindow.l=0
Global _event.l=0
Global _key$=""
Global _value$=""
Global _file_ID=0
Global _ioID=0  ;for I/O 
Global _system_text_base$=""
Global _atom$=""
Global _matrix_size.l=0
Global _matrix_area.l=0
Global _grid_width.f=0
Global _grid_height.f=0
Global _grid_offset_x.f=0
Global _grid_offset_y.f=0
Define dummy.l=ExamineDesktops()
Global _screen_w.f=DesktopWidth(0)   ;use OS desktopdimensions and parameters
Global _screen_h.f=DesktopHeight(0)
Global _screen_d.b=DesktopDepth(0)
Global _screen_f.l=DesktopFrequency(0)
Global _screenID.l=0 ;for windowed and pure screen
Global _windowID.l=0;for windowed screen
Global _global_time.l=ElapsedMilliseconds()
Global _start_time.l=_global_time
Global _grid_R.l=255
Global _grid_G.l=0
Global _grid_B.l=0
Global _hit_x.l
Global _hit_y.l=0
Global _mouse_x.f=0
Global _mouse_y.f=0
Global _l_mouse.b=0
Global _r_mouse.b=0
Global _usr_x.f=0
Global _usr_y.f=0
Global _usr_x1.f=0
Global _usr_y2.f=0
Global _debug_mode=0
Global _debug_object_ID$=""
Global _true.b=0  ;dummy variable 
Global _dpointer.l=0
Global _joy_x.b=0 ;joypad direction
Global _joy_y.b=0
Global _joy_b.b=0 ;joystiuck button
Global _joy_pad.b=#False  ;no joypad?!
Global _screen_smooth.b=0 ;used for own smoothing routine
Global _screen_sprite2D.l=0
Global _screen_sprite3D.l=0 ;used for the smoothing....
Global _multitask.b=#False
Global _multitask_backup.b=0
Global _fileLoadMusic.l=0
Global _fileLoadMusicFile.s=""
Global _map_x_max.l;global variable to hold the maximum x dimension  of map, for manipulation issue
Global _map_y_max.l;global variable to hold the maximum y dimension  of map, for manipulation issue
Global _level_switch.l=0  ;used for automatic screen change (credits..intro...)
Global _level_switch_base.l=0 ;used for automatic screen change (credits..intro...)
Global _bloom.b=0
Global _inwarn.s=""
Global _gui_path.s=""
Global _load_screen_file.s
Global _load_screen_id.l ;2dsprite
Global _load_screen_id3D.l;3dsprite...
Global _last_mapID.l=0 ;is used and changed by engine if map is changed /leave/enter....



;SERVERSECTION FOR SERVER/ONLINE MODE OF INGRID ENGINE; USED TO KEEP GAMEPLAY AT LATEST/ACTUAL STATE
 


 
;**********************************

Global _in_grid_settings.s=""


;some developement internals:
Global FR=0
Global FRt=1000
Global FR$=""

;END

;display handling / gfx sw screenscaler ...for "__REALTIMESCALER() in FWORLD
Global _3D_game_screen.l=0  ; holds the 3Dgfx (grabsprite)
Global _2D_game_screen.l=0  ;holds the "2D" gfx ....
Global _pip.b=0 ;PIP
Global _ob.l=0 ;lazarussystem
;--FILE HANDLING
Global _clear_screen.b =#True
Global _codec_path$=""
Global _sound_codec$=""
Global _music_codec$=""
Global _sound_path$=""
Global _gfx_codec$=""
Global _codec$=""
Global _2dgfx_path$=""
Global _2d_effect_gfx_path.s=""
Global _gfx_path$=""
Global tile_reset.b=0
Global descriptortile$=""
Global _errorGFX.l=0
Global _ok.l=0
Global _dType$=""
Global _dValue$=""
Global _i.l=0
Global _j.l=0
Global _worldftile.l=0
Global _scr_scaleX.f=1
Global _scr_scaleY.f=1
Global _width.f=1
Global _height.f=1
Global _defWidth.f=1
Global _defHeight.f=1
Global _aspectFactor.f=1
Global _aspectCorr.f=1
Global _aspectFactorstring$=""
Global _hor.f=1
Global _app_entry_point.l=0 ;default if no valid entrypoint is found
Global _brain_skript.s=""
;some LUCY-RETIOSCALER vars no more need in MATRIXBUILDER/MATRIXENGINE
Global _newheight.f=1
Global _boxHeight.f=1  ;from LUCY...
Global _win_x.f=0
Global _win_y.f=0
Global _w.f=0
Global _h.f=0
;----------------------------------------------------------
Global _show_mini_map.b=0 ;internal use for realtime minimap of the level.... ;default key= "M" on keyboard, or  "Select" on joystick/pad
Global _map_scale_x.f=1 ;used for minimap system
Global _map_scale_y.f=1 ;used for minimapsystem
Global _global_pause=0 ;the global pausefunction
Global _dynamic_scroll.b=0
Global _scrscx$=""
Global _scrscy$=""
Global _full_screen.f  ;true/false; if true we use 1/2 of desktop size....as resolution/dimension for our gamewindow+windowframe/titlebar.
Global _maxUsedLayer=0
Global _filesprite.l=0
Global dummy$=""
Global _dummy2DSprite.l
Global _mouseH.l
Global _mouseV.l

Global _delmitter.b=0
Global _R.l=0
Global _G.l=0
Global _B.l=0
Global _controller_type=#MOUSE ;default!!! (global setting) is overwritten by  object settings
Global _dtransparency=0
Global  _gameLEVEL.l=0  ;make switch to level "0" if no valid entrypoint is given
Global _actualLEVEL.l=-1000 ;
Global _scale=0
Global l_move_x.b=0 ;used for some keyboard/mouse/joystick values
Global l_move_y.b=0 ;used for some keyboard/mouse/joystick values
Global _gfx_object$ 
Global _object_s=0
Global Dim _gfxW.f(512)
Global Dim _gfxH.f(512)
Global Dim _lucy.l(1) ;hommage to LUCY GameEngine wich was my first try and helped me to learn soooo much about game programming
                      ;organises object IDs to speed up some situations like collisionchecking of multiple objects
                      
Global _max_lucy.l=0
Global _o1$=""
Global _o2$="" ;used as debug info for collsion/lucy output

Global _err_log$=_core$ ;default if no valid script
Global _warn_log$=_core$
Global _no_game_data.b=0

Global _frame_id=0
Global _global_effect=0
Global _area_collision.b=0

;animsystem engine globals:
Global _anim_path$=""

; Global _accu_x.l =0
; Global _accu_y.l  =0 ;for the areaoffset used with the AI-Gris, so we center/keep grid and map at same focus (visible area)




;--


;############ for the default mirrorsystem:
Global _mirror2DSprite.l=0
Global _mirror3DSprite.l=0

;##########################################




;-LISTS


Structure _snd
soundID.l      ;memoryaddress
soundLoop.b    ;play allways
soundISAthmo.b ;play as background athmo -> used for mapareas..
soundPlayOnView.b ;play sound if object is on view
soundPlayOnAction.b ;plays sound if action is done (open dorr..)
soundName.s ;is used with object to chatch the right sound effect connect with the object
EndStructure

Structure  _mirror_object
ID.l
EndStructure

Global Dim _mirrorObject._mirror_object(1)  ;use this as shortcut for mirrorobject calculation, now use max 256 (0-255) objects/mirrors
Global _max_mirror_ID.l=0
Global _max_sounds.l=0

; Structure _WORLD_GRID 
; x.f
; y.f
; w.f
; h.f
; used.b ; free matrix area? or not? stores the object ID as value, not used(free) area value =-1 
; index.b    ;for used (0-16)
; EndStructure

Structure _SPECIAL_GFX  ;3D gfx/sprites for specialeffects like pixeling/blocks .....
gfxID.l
gfx_x.f
gfx_y.f
_2d.l ;holds 2dspritenum!
transparency.l
dest_x.f
dest_y.f
EndStructure


Global Dim _sgfx._SPECIAL_GFX(256,256)
Global Dim _sound._snd(255) ;soundsystem
Global _soundNUM.l=0 ;counter
Global Dim _sound_object$(1)
Global _level_sound.l=-1 ;the standard soundsystem....
Global _play_level_sound.b=1

; Global Dim _GRID._WORLD_GRID(128,128)
 Global _matrix_system_max.l=128 ; = hardcoded to keep valid max matrix size; any value in the ini script <257 and >-1 is valid
;--GFX SYSTEM STRUCT
;----MAIN GFX STRUCT





;------- engine internals
Structure _internalGFX
_gfxID.l
_gfxX.f
_gfxY.f
_gfxW.f
_gfxH.f
_2dGFX_ID.l
_valid.b  ;is sprite3d valid?
EndStructure 

Global Dim ENGINE_GFX._internalGFX(16)
Global _engine_loads_next_map=#False
Global _vwait=1  ;engine waits for screensync: default setting: override it with the ssystemininscript
Global _loadScreen.b ;1=show loadgfx/screen, 0=nothing
Global _doPrefetch.b ;try a simple prefetch for map i/o
Global  _e_scr.l=0
Global _e_scr3D.l=0
Global _e_started.b=0
Global _effect.b=0
Global _engine_2dsprt$=""
Global _engine_parse_line.l=0
Global _debug_path.s=""
Global _use_debug_log.b=0 ;1 = debug log on....
Global GLOBAL_GFX_FX.b=0
Global _text_smooth.b=0 ;no smooth for text as default
Global _end=0 ;game/engine on/off with exit

Enumeration
#ENGINE_LEVEL_LOAD_CIRCLE =1
#ENGINE_LEVEL_LOAD_POINT
#ENGINE_LOAD_SCREEN
#SHLIR
#ENGINE_LEVEL_LOAD
EndEnumeration


Enumeration
#JX_ =1
#JA_
#JB_
#JY_
#LT_ 
#RT_ 
#LB_
#RB_
#SELECT_ 
#START_ 
EndEnumeration


Enumeration 
#KEYBOARD_
#JOYPAD_
#MOUSE_
EndEnumeration


Enumeration  ;for the GFX CONSTANTS
#_DO_STREAM  ; if set engine uses stream system for object
#_DO_NOT_STREAM  ;object is allready loaded/or in use so do NOT stream
#_IS_VALID_GFX  ; replaces IsSprite3d() for realtime check...to save time/speed up
#_IS_NOT_VALID_GFX   
#_REMOVED
#_WAITING
#_READY_FOR_ACTION
#_GFX_REMOVED
#_GFX_CACHED
EndEnumeration

#GAMEOVER=4096

Global _use_input_device.b=-1; joypad/keyboard/mouse...
Global _cache_path.s=""
Global _use_cache.b
Global _collision_check_type.b=0
Global _button.b=-1  ;for the joypadfunctions/keyboard joystick emulation
Global _stream.b ; value =1 or 0 for debugpurpose....
Global _cached.b=0

;---------


Structure _DDDGFX
 worldFTileName.s     ;will be defined with the io routine and dna system
 worldFTileGFXFile.s  ;holds the "plain filename" without path
 worldFTileSaveX.f
 worldFTileSaveY.f ;last "save position" used for location changes like enter room, exit room...
 worldFTileGFX.l
 worldFTileDNAFile.s
 worldFTileIs_GFX.b
 worldFTile2DGFX.l
 worldFTile_2D_EFFECT_GFX.l  ;used as overlay 
 worldFTile_3D_EFFECT_GFX.l  ;used as overlay 
 worldFTile_EFFECT_GFX.s  ;stores the location of the gfx used for effects (connected to the worldFTileGFX)
 worldFTile_Is_EFFECT_GFX.b ;true/false
 worldFTileUseShadow.s  ;holds the shadow filename, file-path is stored by:worldFTile_EFFECT_GFX.s 
 worldFTile_2D_SHADOW.l
 worldFTile_3D_SHADOW.l
 worldFTile_Is_Shadow.b
 worldFTileRandomRotate.l
 worldFTileSourceGFXID.l  ;stores the GGFX() ID of the 2D system; internal use like streaming ...
 worldFTileStreamStatus.b  ;stores the streamstatus (stream it? or not?)
 worldFTileNoScroll.b
 isRotating.b ;internal
 _2DTILEW.f  ;internal
 _2DTILEH.f ;internal
 rescal_w.f ;internal
 rescal_h.f ;internal 
 maxW.f ;internal
 maxH.f ;internal
 worldFTileScale.b ;marker for scaled objects
 worldFTileAnim2DFrameDEFAULT.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnim2DFrameR.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnim2DFrameL.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnim2DFrameU.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnim2DFrameD.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameDEFAULT.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameR.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameL.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameU.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameD.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameRW.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameRH.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameLW.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameLH.l[32]
 worldFTileAnimFrameUW.l[32] ;the anim frame containers (Right, Left, Up, Down) 3D Sprite ID is copied to worldFTileGFX
 worldFTileAnimFrameUH.l[32]
 worldFTileAnimFrameDW.l[32]
 worldFTileAnimFrameDH.l[32]
 worldFTileAnimFrameDEFAULTH.l[32]
 worldFTileAnimFrameDEFAULTW.l[32]
 worldFTileValidMirror.b
 worldFTileAnimFrame.l ;actualFrame (does not check anim direction, will set  to startvalue if animdirection is changed or animframe> maxframes)
 worldFTileMaxFramesDEFAULT.l ;internal
 worldFTileMaxFramesR.l ;internal
 worldFTileFrameR.l
 worldFTileFrameL.l
 worldFTileFrameU.l
 worldFTileFrameD.l  ;internal control for the animframe version 191211
 worldFTileFrameDef.l
 actualDirection.l  ;internal for new animversion or other engine system values for version 191211
 worldFTileIsAnim.b  ;internal use for  version 191211
 worldFTileMaxFramesL.l ;internal
 worldFTileMaxFramesU.l ;internal
 worldFTileMaxFramesD.l ;internal
 worldFTileAnimW.f ;internal
 worldFTileAnimH.f ;internal
 worldFTileMaxAnimFrames.l
 animStartTime.l
 animContainer.s ;holds the animdata
 animTimer.l  ;external skript, default =40 ms = 25 FPS
 animAutoPlay.b
 worldFH.f;offsets (automatic positioning the tiles in the right distance...
 worldFV.f
 worldFTileMaterialIndex.l ;#_grass,#_sand.
 worldFTileCollision.b
 worldFTileType.l
 worldFTileW.f
 worldFTileH.f
 worldFTileCenterX.f ;stores the x-center of the object :for internal use
 worldFTileCenterY.f ;stores the y-center : for internal use
 worldFTileRotate.f
 worldFTileFollow.s
 worldFTileRandomFollow.l
 worldFTileDestinationID.l ;for the followobject to make a simple/fast way for the follow action way
 worldFTileTransparency.f
 worldFTileTransparencyBackUp.l  ;internal
 worldFTileXPOS.f
 worldFTileYPOS.f
 worldFTileGOBACK.l
 worldFTileTouchMove.l
 worldFTileTouchTransparency.l
 worldFTilePlayerID.l
 worldFTileExpansionValueH.f
 worldFTileExpansionValueV.f
 worldFTileIsGUI.b
 worldFStretch.b
 worldFTileAngle.f
 worldFTileMove.f
 worldFTileVELO.f
 worldFTileFadeOutStep.f
 worldFTileVeloV.f  ;for the Parable..
 worldFTileVeloH.f   ;for the Parable
 worldFTilePlayerMOVE.f
 worldFTileGravity.l
 worldFTileScrollH.f    ;autoscroll direction without playerpower, can be combined with useLayerScroll.b
 worldFTileScrollV.f    ;autoscroll direction without playerpower, can be combined with useLayerScroll.b
 worldFTileCollisionDestroy.b
 worldFTileIsActive.b
 worldFTileRemove.b ;internal helper variable  used for some special situations to remove object correctly, will set active <>1 
 worldFTileGlobalGravity.f
 worldFTileFollowObject.l
 worldFTileMoveH.f
 worldFTileMoveV.f
 worldFTileUseMoveLogic.l ;internal for some special move controls (like use horizontal move only...)
 worldFTileUseKeyboard.b
 worldFTileUseStick.b
 worldFTileIsHWMousePointer.b
 worldFTileIsEMUMousePointer.b
 worldFTileTouchRotate.l
 FTileLayer.l ;           we can use layer (back/front/medium ....) actual range: 0...256
 useLayerScroll.b       ;if <>0 paralaxscrolling possible (layer# = velo-factor ) = scrollspeed * layer# 
                           ; useLayerScroll MUST be used in ONE level-tile, do not use this in more than ONE tile as switch (playerObject preferred, because it will be in every level on position and so thhe engine will be able to use the keyword), that will cause multiple scrolling events with chaotic situation
 worldGlobalScrollH.f  
 worldGlobalScrollV.f 
 worldFTileWeight.l ;for simple physics  
 worldFTileShadow.f
 AI.b
 worldFTileTransport.b
 worldFTileFadeOUT.f
 worldFTileFadeIn.f
 worldFTileFadeInStep.f
 worldFTileFlire.f
 worldFTileID.l
 worldFTileIDString.s ;id string if you want to use this instead of "numbers"
 worldFTileORIGW.f  ;internal systemvaribale to use with some effects
 worldFTileORIGH.f  ;internal systemvaribale to use with some effects
 worldFTileORIGX.f
 worldFTileORIGY.f
 hp.l     ;hitpoints if needed...
 max_hp.l ;store the maximumhitpoints of the object....
 worldFTileShowHP.b ;internal use but external changeable 
 useWeapon.s
 worldFTileObjectText.s
 postEFFECT.s
 worldFTileFileSize.l
 worldFTileFollowUseDistance.b
 worldFTileRandomActivateWeapon.l  ;random number if >0 1 is used for activate the weaponfunction/emitter if useweapon = true
 goONX.b ;internal, for collsion stop/go AI
 goONY.b ;internal, for collision stop/go AI
 lastMoveX.f ;internal for AI
 lastMoveY.f ;internal for AI
 geneseID.s  ;use this for the worldcontruction to put / seperate AI Objects from level structure. ...so we make shure that AI objects blitted on the right layer
 worldFTileRandomMove.l
 worldFTileLifeTime.l ;value , resolution is defined by " worldFTileTimerMS.l"
 worldFTileTimerMS.l ;timer resolution
 worldFTileStartTime.l ;internal Helper for the objecttimer
 worldFTileAutoMove.b
 worldFTileUseTimer.b
 worldFTileHideOnStart.b
 playerSCORE.l  ;now we show /store the score to the object!!!!
 worldFTileAutoLayer.b ;is used if you want to set layers to objects, so you can build your map without thinking of layers...,  defaultvalue=-1 = OFF!!!
 worldFTileValidStreamAnim.b                                       ;          nal use....so we can make it "blink" If colided With enemy Or If we like.... (does Not infect standard settings setable thru builder                 
 inUse.b  ;internal variable (ex: you can check with this if "your" object is doing something
 usedBy.l ; internal variable stores the index of the object which started the object/action (inUse.b) :ex you activate a shot: bullet stores the index of the object which did the shot, and you can set this object as  "inUse", so you prevent from shooting all ammo with one enemy/shotgun....
;  worldFTileAIX.l[16];internal AI stores... if maximum (16) is reached the first one will be overwritten by new data (FIFO)
;  worldFTileAIY.l[16] ;internal stores up to 16 steps (brain) of AI for AI-movement -> Is AIX= free Area or used..(FIFO)
;  worldFTileAI.l[16] ;internal store of 16 AI actions/Responses (FIFO)
 worldFTileIsMirror.l ;if value>0 this object is used as mirror tile value= mirro pic transparency
 worldFTileMirrorAt.s ;the reflection direction
 worldFTileIsSound.b  ;true/false
 worldFTileSoundPlayOnAction.b  ;like collision....
 worldFTilePlaySoundOnView.b  ;if is in screen start the sound ...
 worldFTileSoundFile.s ;stores stringId of  connected sound
 worldFTileSoundIndex.l ; internal value with direct access to sound file counterindex...
 worldFTileSoundDuration.l ;milliseconds
 worldFTileSoundStartTime.l ;elapsedmilliseconds..start value INTERNAL
 worldFTileSoundVolume.b ;up to 100 or down to 0 ; every object can use its own soundvolume!
 worldFTileIsInScreen.b ;internal varibale set this for fast detection if object is in visible zone.
 worldFTileSoundType.s  ;used for definition if  is env or objectsound (water/wind/rain = worldsound, walksound = objectsound.....)
 button_pressed.b ;here we check keyboard/joypad buttons pressed in combination with objectactivity , used for humancontrolled objects
 worldFTileSoundIsPlaying.b ;internal control
 worldFTileRandomSound.l  ;if >0 we use value as random base...for sound activating
 worldFTileKillOutOfScreen.b
 weaponPower.l ;weaponpower!
 worldFTileAILevel.b
 worldFTileMoveLogic.b ;internal...
 worldFTileAllDirections.b ;internal ..1 = all direction , 0 = do not touch  direction setting!!!!  (used for engine controlled animobjects)
 noStream.b ;1=no streamobject!
 isValid.b 
 streamTimer.l  ;used for timebased maprefresh so we do NOT use instant stream, because of performance issues, if time is elapsed and object out of vie the system will remove graphics data from videoram
 streamTimerBase.l
 worldFTileIsWeapon.b  ;internal use for faster weapon/emitteraction
 worldFTileWeaponPower.l
 worldFTileWeaponUseage.l ;counts weapon activations ;for gamepart
 worldFTileMaxWeaponUseage.l  ;stores the maximum of weaponuse handled / used by gamepart, controlled with the dna system
 worldFTileDynamicVelo.b ;if velo at object load <>0 we use this flag for the touchmove: if  0 we decrease value of velo to 0, if <>0 we decrease to origin velo
 worldFTileinGameLiveTime.l
 worldFTileinGameLiveTimeCounter.l
 worldFTileinGameActualLiveTime.l
 EndStructure
  
 
 
 
  Structure pars
  _keyword.s
  _close_parse.b
  EndStructure

 Global _pars.pars
 
 Global Dim _3DGFXOBJECT._DDDGFX(1)
 #MAX_MAP_OBJECTS=1 ;use this as workaround for maps > 4096 objects (we will redim the structure)
 
 Structure __2DGFX_ID
 link.s ;filepath
 gfx_id.l ;2Dbitmapid used for 3dgfx
 isGFX.b
 EndStructure
 
 Global Dim _2DGFX_ID.__2DGFX_ID(512)  ;for the 2d bitmapcache
 Global _2dgfx_id_index.l=0 ;counter/index
 Global _2dgfx_id_max_index.l=0 ;counter/index
 
 
 
 
 
 
 
  ;some basic settings for AI
  ;Global _max_brain=16 ; hardcoded for now..will be replaced by scripting, is used for ai steps
  Global _maxanimframes.l=1 ;default NO ANIMFRAMES, correct value is read from ini script
  Global _PLAYER_ID.l ;internal use for singleplayer stats to make it faster response....
  Global _max_players.l=0 ;if >0 we can play (up to 255)
  Global _fuel$ =""  ;for the flamethrower
  Global _max_fuel.b=0 ;for the fuel bar
  Global _fuel_control.l=0 ;if count to 0 we remove  one fuel potion
  Global _fuel_back_up.l=0 ;we store the fuelvalue for game/level restart/next level we start with the default value
  
  ;some gfx organisations for speed up the blitting:
 
 ;#########################################
 
 ;the fontengine objects:
 Global _blitt_start.l=0; first object for the blitter object/displayroutine
 Global _blit_end.l = 0 ; last object for the blitterobject / displayroutine
 
 ;end 
 
 Structure  _font
 _fontX.f
 _fontY.f
 _fontH.f
 _fontW.f
 _font2DGFXID.l
 _font3DGFXID.l
 _fontSRC.s  ;holds the "FONTOBJECT NAME" ("A","B"....)
 _fontValid.b  ;if <>0 we can use it, soi we do not need to check for the big 2D/3D Values...
 EndStructure
 
 
 Global Dim MyFont._font(255)  ;dim= Max Font/Objects=CHAR/ASCCODE
 Global _fontFundament.s=""  ;stores the fontstring destination ("ABCDEFGHIJKLMNOPQRSTUVWXYZ......") defined in the iniscript
 Global _font.s=""
 ;ingame_special variables:used for game only, no engine part!
 

 Global _live$=""
;  Global _floppy_snd.l=0 ;for the loading sfx its a internal function so we use a static system
;  Global _floppy_snd_is_playing.b=#False
;  Global _floppy_snd_timer.l=3000 ;static for now....
;  Global _floppy_start_snd.l=ElapsedMilliseconds()
 Global _load_screen.l=0
 Global _load_screen2D.l=0
 Global _emitter_object.l  = 0
 Global _max_emitter_object.l=0
 Global _gameOver=#False
 Global _engine_error.b=0  ;internal use
 Global _player_score.l=0  ;the score storage
 
 Global _switch_gfx_path$=""
 Global _2dgfx_path_backup$=""
 
 
 ;for the ingame timer: we use framespeed ...
 Global _actual_frame.l=0
 Global _frame_level.l =0  ;if frameId=> FPs we count+1 or -1 using "ingame time"
 Global _ingame_start_time.l=0 
 Global _ingame_stop_time.l=0
 Global _ingame_time.l=0  
 Global _ingame_show_time.l=0
 Global _timer_base.l=50;script controlled timer event (if _ingame_time> value or <0-value _ingame_show_time+1 or _ingame_show_time-1)
 
 Global  _window_w.l=0
 Global _window_h.l=0
 Global _window_hd.b=0
                                                
                                       
 
 
 ;inventory structure
 
 Structure inventory
 InventoryObject.s
 InventoryObjectSize.l  ;holds the ammount of objects  (eg: 200 x ammo)
  EndStructure 
 
 Global Dim  _inventory.inventory(126)
 Global Dim _emitter(1)
 
 
 ;for the blitorga system:
 Global Dim _blitter_object.l(1024) ;holds the _3DGFXF_list_ID of the object
 Global _blitter_object_counter.l=-1  ;counter for the objectsystem...
 Global _blitter_object_debug_info.l=0
 ;-----------------------------
 
 
 ;INVENTORY OBJECTS CONSTANTS:
 
 Enumeration
 #fuel=1
 #idcard
 #money
 #alife
 #lifeguiback
 #fuelguiback
 EndEnumeration
 
 Global _did_frame.b=0







; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 499
; FirstLine = 471
; Folding = -
; EnableXP
; EnableOnError
; Executable = warpzone_040611.exe
; CPU = 5
; SubSystem = DX9
; DisableDebugger