

Procedure __DNA_CONTROLLER(_d.l)
;here we reset some internals:

If _3DGFXOBJECT(_d.l)\worldFTileIDString="LAUB"
_3DGFXOBJECT(_d.l)\useWeapon=""
EndIf

EndProcedure


Procedure __BLIT_OPTIMIZER()

;do not use this routine / procedure  it consumes more cycles in big maps and stop/freezes gameplay
; _blitter_object_counter.l=0  ;reset
; Define _d.l=0
; For _d.l=0 To _worldftile
; If _3DGFXOBJECT(_d.l)\worldFTileIsInScreen=1 
; _blitter_object.l(_blitter_object_counter)=_d.l
; _blitter_object_counter+1
; EndIf
; 
; Next


EndProcedure

Procedure __GFXCONTROLLER(_d.l)
;checks if grfx is in screen/valid for blitting... 
;used for the streamingsystem...




If (_3DGFXOBJECT(_d.l)\worldFH+_3DGFXOBJECT(_d.l)\worldFTileW)>0 And  _3DGFXOBJECT(_d.l)\worldFH<_screen_w And (_3DGFXOBJECT(_d.l)\worldFV+_3DGFXOBJECT(_d.l)\worldFTileH)>0 And  _3DGFXOBJECT(_d.l)\worldFV<_screen_h 
  
          _blitter_object_counter.l+1 
          _blitter_object.l(_blitter_object_counter)=_d.l
          _3DGFXOBJECT(_d.l)\worldFTileIsInScreen=1  ;it is visible
          _3DGFXOBJECT(_d.l)\worldFTileValidMirror=1
          _3DGFXOBJECT(_d.l)\streamTimerBase=ElapsedMilliseconds() ;for the "intelligent dynamic streaming system if time elapsed and object out of view, kill videodata
       Else
         _3DGFXOBJECT(_d.l)\worldFTileIsInScreen=0  ;it is not in visible area (screen)
         _3DGFXOBJECT(_d.l)\worldFTileValidMirror=0
 EndIf
 
 _blitter_object_debug_info.l= _blitter_object_counter.l  
 EndProcedure

Procedure __RESET_SIZE(_d.l)

;for the dynamic zoom system if we want to restore the origin/startsize of the object
              _3DGFXOBJECT(_d.l)\worldFTileH=_3DGFXOBJECT(_d.l)\maxH;*_scr_scaleY
              _3DGFXOBJECT(_d.l)\worldFTileW=_3DGFXOBJECT(_d.l)\maxW;*_scr_scaleX


EndProcedure 

Procedure __EXPANSION(_d)
;here we resize the object....
;code
_3DGFXOBJECT(_d)\worldFTileW+_3DGFXOBJECT(_d)\worldFTileExpansionValueH
_3DGFXOBJECT(_d)\worldFTileH+_3DGFXOBJECT(_d)\worldFTileExpansionValueV

If _3DGFXOBJECT(_d)\worldFTileW<=0
_3DGFXOBJECT(_d)\worldFTileW=_3DGFXOBJECT(_d)\maxW
EndIf
If _3DGFXOBJECT(_d)\worldFTileH<=0
_3DGFXOBJECT(_d)\worldFTileH=_3DGFXOBJECT(_d)\maxH
EndIf
If _3DGFXOBJECT(_d)\worldFTileIs_GFX=#True
ZoomSprite3D(_3DGFXOBJECT(_d)\worldFTileGFX,_3DGFXOBJECT(_d)\worldFTileW,_3DGFXOBJECT(_d)\worldFTileH)
EndIf
;code.....

EndProcedure






Procedure __ANIM_DEFAULT(_d)
Define _etime.l = ElapsedMilliseconds()
Define _go



If _etime.l>(_3DGFXOBJECT(_d)\animStartTime+_3DGFXOBJECT(_d)\animTimer) And _3DGFXOBJECT(_d)\animTimer<>0

_3DGFXOBJECT(_d)\animStartTime=ElapsedMilliseconds()


If _3DGFXOBJECT(_d)\worldFTileFrameDef<_3DGFXOBJECT(_d)\worldFTileMaxFramesDEFAULT
                    
        _3DGFXOBJECT(_d)\worldFTileFrameDef+1
                    
       ; _3DGFXOBJECT(_d)\worldFTileGFX=_3DGFXOBJECT(_d)\worldFTileAnimFrameDEFAULT[_3DGFXOBJECT(_d)\worldFTileAnimFrame] ;try a simple adresscopy...
     Else
        
        _3DGFXOBJECT(_d)\worldFTileFrameDef=1
        ;_3DGFXOBJECT(_d)\worldFTileGFX=_3DGFXOBJECT(_d)\worldFTileAnimFrameDEFAULT[_3DGFXOBJECT(_d)\worldFTileAnimFrame] ;try a simple adresscopy...
      
EndIf
  _3DGFXOBJECT(_d)\worldFTileW= _3DGFXOBJECT(_d)\worldFTileAnimFrameDEFAULTW[_3DGFXOBJECT(_d)\worldFTileFrameDef]
  _3DGFXOBJECT(_d)\worldFTileH= _3DGFXOBJECT(_d)\worldFTileAnimFrameDEFAULTH[_3DGFXOBJECT(_d)\worldFTileFrameDef]
  ;ZoomSprite3D(_3DGFXOBJECT(_d)\worldFTileGFX,_3DGFXOBJECT(_d)\worldFTileAnimFrameDEFAULTW[_3DGFXOBJECT(_d)\worldFTileAnimFrame],_3DGFXOBJECT(_d)\worldFTileAnimFrameDEFAULTH[_3DGFXOBJECT(_d)\worldFTileAnimFrame])


EndIf  ;animtimer?

EndProcedure


Procedure __ANIM_VERTICAL(_d)
Define _etime.l = ElapsedMilliseconds()
Define _go



If _etime.l>(_3DGFXOBJECT(_d)\animStartTime+_3DGFXOBJECT(_d)\animTimer) And _3DGFXOBJECT(_d)\animTimer<>0

_3DGFXOBJECT(_d)\animStartTime=ElapsedMilliseconds()

Select _3DGFXOBJECT(_d)\worldFTileMoveV

Case 1

_3DGFXOBJECT(_d)\actualDirection=#MOVE_DOWN

If _3DGFXOBJECT(_d)\worldFTileFrameD<_3DGFXOBJECT(_d)\worldFTileMaxFramesD
       
              
        _3DGFXOBJECT(_d)\worldFTileFrameD+1
       

        Else
        
       _3DGFXOBJECT(_d)\worldFTileFrameD=1
        

EndIf
      
  _3DGFXOBJECT(_d)\worldFTileW= _3DGFXOBJECT(_d)\worldFTileAnimFrameDW[_3DGFXOBJECT(_d)\worldFTileFrameD]
  _3DGFXOBJECT(_d)\worldFTileH= _3DGFXOBJECT(_d)\worldFTileAnimFrameDH[_3DGFXOBJECT(_d)\worldFTileFrameD]

Case -1

_3DGFXOBJECT(_d)\actualDirection=#MOVE_UP

If _3DGFXOBJECT(_d)\worldFTileFrameU<_3DGFXOBJECT(_d)\worldFTileMaxFramesU
       
        _3DGFXOBJECT(_d)\worldFTileFrameU+1
       

        Else
        
        _3DGFXOBJECT(_d)\worldFTileFrameU=1
        

EndIf

          
  _3DGFXOBJECT(_d)\worldFTileW= _3DGFXOBJECT(_d)\worldFTileAnimFrameUW[_3DGFXOBJECT(_d)\worldFTileFrameU]
  _3DGFXOBJECT(_d)\worldFTileH= _3DGFXOBJECT(_d)\worldFTileAnimFrameUH[_3DGFXOBJECT(_d)\worldFTileFrameU]




EndSelect




     
If _3DGFXOBJECT(_d)\worldFTileW>_3DGFXOBJECT(_d)\maxW 
_3DGFXOBJECT(_d)\maxW=_3DGFXOBJECT(_d)\worldFTileW
EndIf

If _3DGFXOBJECT(_d)\worldFTileH>_3DGFXOBJECT(_d)\maxH
_3DGFXOBJECT(_d)\maxH=_3DGFXOBJECT(_d)\worldFTileH
EndIf



EndIf  ;animtimer?



EndProcedure





Procedure __ANIM_HORIZONTAL(_d)

Define _etime.l = ElapsedMilliseconds()
Define _go


If _etime.l>(_3DGFXOBJECT(_d)\animStartTime+_3DGFXOBJECT(_d)\animTimer) And _3DGFXOBJECT(_d)\animTimer<>0

_3DGFXOBJECT(_d)\animStartTime=ElapsedMilliseconds()



Select _3DGFXOBJECT(_d)\worldFTileMoveH

Case 1

_3DGFXOBJECT(_d)\actualDirection=#MOVE_RIGHT

If _3DGFXOBJECT(_d)\worldFTileFrameR<_3DGFXOBJECT(_d)\worldFTileMaxFramesR
       
              
        _3DGFXOBJECT(_d)\worldFTileFrameR+1
        
         

        Else
        
        _3DGFXOBJECT(_d)\worldFTileFrameR=1
        
         
         

EndIf
      
  _3DGFXOBJECT(_d)\worldFTileW= _3DGFXOBJECT(_d)\worldFTileAnimFrameRW[_3DGFXOBJECT(_d)\worldFTileAnimFrame]
  _3DGFXOBJECT(_d)\worldFTileH= _3DGFXOBJECT(_d)\worldFTileAnimFrameRH[_3DGFXOBJECT(_d)\worldFTileAnimFrame]

Case -1

_3DGFXOBJECT(_d)\actualDirection=#MOVE_LEFT

If _3DGFXOBJECT(_d)\worldFTileFrameL<_3DGFXOBJECT(_d)\worldFTileMaxFramesL
       
        _3DGFXOBJECT(_d)\worldFTileFrameL+1
     
       

        Else
        
        _3DGFXOBJECT(_d)\worldFTileFrameL=1
        
        
       

EndIf

          
  _3DGFXOBJECT(_d)\worldFTileW= _3DGFXOBJECT(_d)\worldFTileAnimFrameLW[_3DGFXOBJECT(_d)\worldFTileAnimFrame]
  _3DGFXOBJECT(_d)\worldFTileH= _3DGFXOBJECT(_d)\worldFTileAnimFrameLH[_3DGFXOBJECT(_d)\worldFTileAnimFrame]



EndSelect

;work around for anim/frame size used in collision routine...
If _3DGFXOBJECT(_d)\worldFTileW>_3DGFXOBJECT(_d)\maxW 
_3DGFXOBJECT(_d)\maxW=_3DGFXOBJECT(_d)\worldFTileW
EndIf

If _3DGFXOBJECT(_d)\worldFTileH>_3DGFXOBJECT(_d)\maxH
_3DGFXOBJECT(_d)\maxH=_3DGFXOBJECT(_d)\worldFTileH
EndIf


EndIf  ;animtimer?


EndProcedure




Procedure __EXTERMINATION(_d)
;this proc handles all object situations (out of screen) inactive/kill object from map...

If _3DGFXOBJECT(_d)\worldFTileKillOutOfScreen<>0  ;we do not need the real gfx/object name, we use a DNA key, so we can change situation without changing appcode

If _3DGFXOBJECT(_d)\worldFTileIsInScreen=0
__STREAM_OBJECT_SOUND_REMOVE(_d.l)
__STREAM_REMOVE_GFX20(_d.l)
_3DGFXOBJECT(_d)\worldFTileIsActive=0
_3DGFXOBJECT(_3DGFXOBJECT(_d.l)\usedBy)\inUse=0 ;set it valid state
_3DGFXOBJECT(_d.l)\usedBy=0
_3DGFXOBJECT(_d.l)\inUse=0

EndIf
EndIf


EndProcedure


;NEW VERSION OF THE SGFX SYSTEM (BASED on some LUCY functions)
Procedure __LEFT_MIRROR(_i.l)
;called from FWORLD()
;this is a specialgfx routine for objects, which work as mirrors (glas/mirrors....)
;here we try to catch the mirror objects and display them (this is one of the new posteffects)
If _3DGFXOBJECT(_i.l)\worldFTileIsMirror>0  ;is it a mirrorobject?, value >0 is used as transparency value!
Define x.f,y.f,h.f,w.f


  If IsSprite3D(_mirror3DSprite)
         FreeSprite3D(_mirror3DSprite)  
         
         ;check if the 2dsprite is in use:
    If IsSprite(_mirror2DSprite)
      ;free it for new use:
      FreeSprite(_mirror2DSprite)
     
    EndIf
          
   EndIf
    
    

    ;now grab the sprite:
    ;we have to grab the "mirrorarea" from mirror bottom to the mirror height and width
    
     _mirror2DSprite=GrabSprite(#PB_Any,_3DGFXOBJECT(_i.l)\worldFH-_3DGFXOBJECT(_i.l)\worldFTileW+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileW*1.2,_3DGFXOBJECT(_i.l)\worldFTileH, #PB_Sprite_Texture)
    ;same as 2dsprite:
    
    
    If IsSprite(_mirror2DSprite)
       _mirror3DSprite=CreateSprite3D(#PB_Any,_mirror2DSprite)
     ZoomSprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFTileW,_3DGFXOBJECT(_i.l)\worldFTileH)
     DisplaySprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFH+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileIsMirror)

      
      ;now transform it to mirror object...
      
;    x.f=_3DGFXOBJECT(_i.l)\worldFH;+_grid_offset_x
;    y.f=_3DGFXOBJECT(_i.l)\worldFV;+_grid_offset_y
;    h.f=_3DGFXOBJECT(_i.l)\worldFTileH;+_grid_offset_y
;    w.f=_3DGFXOBJEcT(_i.l)\worldFTileW;+_grid_offset_x
;       
  
 EndIf 
 EndIf   
 



EndProcedure


Procedure __FLOOR_MIRROR(_i.l)
;called from FWORLD()
;this is a specialgfx routine for objects, which work as mirrors (glas/mirrors....)
;here we try to catch the mirror objects and display them (this is one of the new posteffects)
If _3DGFXOBJECT(_i.l)\worldFTileIsMirror>0  ;is it a mirrorobject?, value >0 is used as transparency value!
Define x.f,y.f,h.f,w.f

 ;If (_3DGFXOBJECT(_i.l)\worldFH+_3DGFXOBJECT(_i.l)\worldFTileW)<_screen_w And _3DGFXOBJECT(_i.l)\worldFH>0 And (_3DGFXOBJECT(_i.l)\worldFV+_3DGFXOBJECT(_i.l)\worldFTileH)<_screen_h And _3DGFXOBJECT(_i.l)\worldFV>0


 If IsSprite3D(_mirror3DSprite)
         FreeSprite3D(_mirror3DSprite) 
           ;check if the 2dsprite is in use:
    If IsSprite(_mirror2DSprite)
      ;free it for new use:
      FreeSprite(_mirror2DSprite)
    EndIf
 EndIf
    
  

    ;now grab the sprite:
    ;we have to grab the "mirrorarea" from mirror bottom to the mirror height and width
  
    _mirror2DSprite=GrabSprite(#PB_Any,_3DGFXOBJECT(_i.l)\worldFH+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileW*1.1,_3DGFXOBJECT(_i.l)\worldFTileH*1.1, #PB_Sprite_Texture)
    ;same as 2dsprite:
      If IsSprite(_mirror2DSprite)
         _mirror3DSprite=CreateSprite3D(#PB_Any,_mirror2DSprite)
       ZoomSprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFTileW,_3DGFXOBJECT(_i.l)\worldFTileH)
  
    DisplaySprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFH+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileIsMirror)

EndIf
EndIf


 ;EndIf ;in screen?

EndProcedure


Procedure __TOP_MIRROR(_i.l)
;called from FWORLD()
;this is a specialgfx routine for objects, which work as mirrors (glas/mirrors....)
;here we try to catch the mirror objects and display them (this is one of the new posteffects)
If _3DGFXOBJECT(_i.l)\worldFTileIsMirror>0  ;is it a mirrorobject?, value >0 is used as transparency value!
Define x.f,y.f,h.f,w.f

 ;If (_3DGFXOBJECT(_i.l)\worldFH+_3DGFXOBJECT(_i.l)\worldFTileW)<_screen_w And _3DGFXOBJECT(_i.l)\worldFH>0 And (_3DGFXOBJECT(_i.l)\worldFV+_3DGFXOBJECT(_i.l)\worldFTileH)<_screen_h And _3DGFXOBJECT(_i.l)\worldFV>0
  If IsSprite3D(_mirror3DSprite)
         FreeSprite3D(_mirror3DSprite) 
          ;check if the 2dsprite is in use:
    If IsSprite(_mirror2DSprite)
      ;free it for new use:
      FreeSprite(_mirror2DSprite)
    
    EndIf

          
    EndIf
   
    ;now grab the sprite:
    ;we have to grab the "mirrorarea" from mirror bottom to the mirror height and width
  
    _mirror2DSprite=GrabSprite(#PB_Any,_3DGFXOBJECT(_i.l)\worldFH+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV-_3DGFXOBJECT(_i.l)\worldFTileH+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileW,_3DGFXOBJECT(_i.l)\worldFTileH*1.2, #PB_Sprite_Texture)
    ;same as 2dsprite:
    
    
    If IsSprite(_mirror2DSprite)
       _mirror3DSprite=CreateSprite3D(#PB_Any,_mirror2DSprite)
       ZoomSprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFTileW,_3DGFXOBJECT(_i.l)\worldFTileH)
      
      
      ;now transform it to mirror object...
      
;    x.f=_3DGFXOBJECT(_i.l)\worldFH;+_grid_offset_x
;    y.f=_3DGFXOBJECT(_i.l)\worldFV;+_grid_offset_y
;    h.f=_3DGFXOBJECT(_i.l)\worldFTileH;+_grid_offset_y
;    w.f=_3DGFXOBJEcT(_i.l)\worldFTileW;+_grid_offset_x
;       

    DisplaySprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFH+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileIsMirror)

EndIf
  
 EndIf 

 ;EndIf ;in screen?

EndProcedure



Procedure __DEFAULT_MIRROR(_i.l)
;called from FWORLD()
;this is a specialgfx routine for objects, which work as mirrors (glas/mirrors....)
;here we try to catch the mirror objects and display them (this is one of the new posteffects)
If _3DGFXOBJECT(_i.l)\worldFTileIsMirror>0  ;is it a mirrorobject?, value >0 is used as transparency value!
Define x.f,y.f,h.f,w.f

 ;If (_3DGFXOBJECT(_i.l)\worldFH+_3DGFXOBJECT(_i.l)\worldFTileW)<_screen_w And _3DGFXOBJECT(_i.l)\worldFH>0 And (_3DGFXOBJECT(_i.l)\worldFV+_3DGFXOBJECT(_i.l)\worldFTileH)<_screen_h And _3DGFXOBJECT(_i.l)\worldFV>0
    
    If IsSprite3D(_mirror3DSprite)
         FreeSprite3D(_mirror3DSprite) 
           ;check if the 2dsprite is in use:
    If IsSprite(_mirror2DSprite)
      ;free it for new use:
      FreeSprite(_mirror2DSprite)
   
    EndIf
            
    EndIf
  

    ;now grab the sprite:
    ;we have to grab the "mirrorarea" from mirror bottom to the mirror height and width
   
    _mirror2DSprite=GrabSprite(#PB_Any,_3DGFXOBJECT(_i.l)\worldFH+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV+_3DGFXOBJECT(_i.l)\worldFTileH+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileW,_3DGFXOBJECT(_i.l)\worldFTileH*1.2, #PB_Sprite_Texture)
    ;same as 2dsprite:
    
    
    If IsSprite(_mirror2DSprite)
       _mirror3DSprite=CreateSprite3D(#PB_Any,_mirror2DSprite)
       ZoomSprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFTileW,_3DGFXOBJECT(_i.l)\worldFTileH)
      
      
      ;now transform it to mirror object...
      
;    x.f=_3DGFXOBJECT(_i.l)\worldFH;+_grid_offset_x
;    y.f=_3DGFXOBJECT(_i.l)\worldFV;+_grid_offset_y
;    h.f=_3DGFXOBJECT(_i.l)\worldFTileH;+_grid_offset_y
;    w.f=_3DGFXOBJEcT(_i.l)\worldFTileW;+_grid_offset_x
       

    DisplaySprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFH+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileIsMirror)
    EndIf
  EndIf

 ;EndIf ;in screen?

EndProcedure


Procedure __RIGHT_MIRROR(_i.l)
;called from FWORLD()
;this is a specialgfx routine for objects, which work as mirrors (glas/mirrors....)
;here we try to catch the mirror objects and display them (this is one of the new posteffects)
If _3DGFXOBJECT(_i.l)\worldFTileIsMirror>0  ;is it a mirrorobject?, value >0 is used as transparency value!
Define x.f,y.f,h.f,w.f

 ;If (_3DGFXOBJECT(_i.l)\worldFH+_3DGFXOBJECT(_i.l)\worldFTileW)<_screen_w And _3DGFXOBJECT(_i.l)\worldFH>0 And (_3DGFXOBJECT(_i.l)\worldFV+_3DGFXOBJECT(_i.l)\worldFTileH)<_screen_h And _3DGFXOBJECT(_i.l)\worldFV>0
   
   If IsSprite3D(_mirror3DSprite)
         FreeSprite3D(_mirror3DSprite) 
          
    ;check if the 2dsprite is in use:
    If IsSprite(_mirror2DSprite)
      ;free it for new use:
      FreeSprite(_mirror2DSprite)
      _mirror2DSprite=0
    EndIf
             
    EndIf
   

    ;now grab the sprite:
    ;we have to grab the "mirrorarea" from mirror bottom to the mirror height and width
     _mirror2DSprite=GrabSprite(#PB_Any,_3DGFXOBJECT(_i.l)\worldFH+_3DGFXOBJECT(_i.l)\worldFTileW+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileW*1.2,_3DGFXOBJECT(_i.l)\worldFTileH, #PB_Sprite_Texture)
    ;same as 2dsprite:
    
    
    If IsSprite( _mirror2DSprite)
       _mirror3DSprite=CreateSprite3D(#PB_Any,_mirror2DSprite)
       ZoomSprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFTileW,_3DGFXOBJECT(_i.l)\worldFTileH)
      
      
      ;now transform it to mirror object...
      
;    x.f=_3DGFXOBJECT(_i.l)\worldFH;+_grid_offset_x
;    y.f=_3DGFXOBJECT(_i.l)\worldFV;+_grid_offset_y
;    h.f=_3DGFXOBJECT(_i.l)\worldFTileH;+_grid_offset_y
;    w.f=_3DGFXOBJEcT(_i.l)\worldFTileW;+_grid_offset_x
;       
    ; TransformSprite3D(_mirror3DSprite,x.f,y.f+h.f,x.f+w.f,y.f+h.f,x.f,y.f,x.f+w.f,y.f) ;buggy
    DisplaySprite3D(_mirror3DSprite,_3DGFXOBJECT(_i.l)\worldFH+_grid_offset_x,_3DGFXOBJECT(_i.l)\worldFV+_grid_offset_y,_3DGFXOBJECT(_i.l)\worldFTileIsMirror)
  EndIf
  EndIf


 ;EndIf ;in screen?

EndProcedure




Procedure __FADE_IN(_d.l)
;simple faderoutine
If _show_mini_map=0
       
       If _3DGFXOBJECT(_d)\worldFTileFadeIn>0
       
       _3DGFXOBJECT(_d)\worldFTileFadeIn+_3DGFXOBJECT(_d)\worldFTileFadeInStep  ;fade it in
       
       Else
       
       _3DGFXOBJECT(_d)\worldFTileFadeIn=0  ;set it to a real state
       
       
       EndIf
       
 EndIf
        
EndProcedure


Procedure __FADE_OUT(_d.l)
;simple faderoutine
If _show_mini_map=0
       
       If _3DGFXOBJECT(_d)\worldFTileFadeOut>0
       
       _3DGFXOBJECT(_d)\worldFTileFadeOut-_3DGFXOBJECT(_d)\worldFTileFadeOutStep  ;fade it in
       
       Else
       
       _3DGFXOBJECT(_d)\worldFTileFadeOut=0  ;set it to a real state
       
       
       EndIf
       
 EndIf
        
EndProcedure




; Procedure __DO_OBJECT_TIMING()
; Define _o.l=0
; 
; For _o.l=0 To _worldftile.l
; If _3DGFXOBJECT(_o.l)\worldFTileLifeTime<>0
; _3DGFXOBJECT(_o.l)\worldFTileLifeTime-1
; 
; ;default handling
; If _3DGFXOBJECT(_o.l)\worldFTileLifeTime<1
; _3DGFXOBJECT(_o.l)\worldFTileIsActive=0 ;remove it 
; _3DGFXOBJECT(_o.l)\worldFTileLifeTime=0
; EndIf
; 
; EndIf
; Next
; 
; EndProcedure


; Procedure __OBJECT_TIMER(_ii.l)
; ;objectspecific timer (faster than __GLOBAL_TIMER())
; 
; If _3DGFXOBJECT(_ii.l)\worldFTileLifeTime>0
; 
; If (_3DGFXOBJECT(_ii.l)\worldFTileStartTime+_3DGFXOBJECT(_ii.l)\worldFTileTimerMS)<ElapsedMilliseconds()
;     ;new timer base:
;   _3DGFXOBJECT(_ii.l)\worldFTileStartTime=ElapsedMilliseconds()+_3DGFXOBJECT(_ii.l)\worldFTileTimerMS
;   
;   _3DGFXOBJECT(_ii.l)\worldFTileLifeTime-1
;   
;   If _3DGFXOBJECT(_ii.l)\worldFTileLifeTime<1
;       _3DGFXOBJECT(_ii.l)\worldFTileIsActive=0  ;time is over remove the object from the map
;       _3DGFXOBJECT(_3DGFXOBJECT(_ii.l)\usedBy)\inUse=0  ;remove it from  the used list if is emitterobhect..
;       _3DGFXOBJECT(_ii.l)\usedBy=-1
;       If _3DGFXOBJECT(_ii.l)\worldFTileIsSound=#True
;       StopSound(_3DGFXOBJECT(_ii.l)\worldFTileSoundIndex)
;       EndIf
;   
;   EndIf
; 
; EndIf
; 
; EndIf
; 
; 
; EndProcedure
; 
; Procedure __GLOBAL_TIMER()
; Define _counter_ms=1000;
; 
; If _global_time>_start_time
;    ;call routine
;     __DO_OBJECT_TIMING()
;     _start_time=_global_time+_counter_ms
; EndIf
; EndProcedure


Procedure __EMIT_OBJECT(_obj.l,_src_h.f,_src_v.f,_j.l)
Define _ix.l=0,deram.b=0
;here we do the object specific selection, how to use depents on the "game"-situation



If Random(_3DGFXOBJECT(_j.l)\worldFTileRandomActivateWeapon)=0  ;effect is used if dna-value >0, (eg: 10) if random=0 we do it...(used for fire and other effects we start objects asynchron)

                     
                           


              Select _3DGFXOBJECT(_obj.l)\worldFTileIDString
              
              
                    Case "REDVIRUS"
                    
                    __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                                   
                      _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1  
                        
                        
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f+_3DGFXOBJECT(_j.l)\worldFTileH
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                        ; _3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                         _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
                   
                         
                   
                    Case "REDFIRE"
                    
                      __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                    If _3DGFXOBJECT(_obj.l)\worldFTileIsInScreen=1
                   
                        _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1  
                       
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f+_3DGFXOBJECT(_j.l)\worldFTileH
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                        ; _3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                         _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
                                 
                           
                           
                             ;some special seting sfor directional fire  caused on the emiiter idstring
                              Select _3DGFXOBJECT(_j.l)\worldFTileIDString ;the direction
                              
                              Case "FIRED"
                              
                              _3DGFXOBJECT(_obj.l)\worldFTileMoveH=0
                              _3DGFXOBJECT(_obj.l)\worldFTileMoveV=1
                              
                              Case "FIREL"
                                                            
                              _3DGFXOBJECT(_obj.l)\worldFTileMoveH=-1
                              _3DGFXOBJECT(_obj.l)\worldFTileMoveV=0
                              
                              Case "FIREU"
                                                           
                              
                              _3DGFXOBJECT(_obj.l)\worldFTileMoveH=0
                              _3DGFXOBJECT(_obj.l)\worldFTileMoveV=-1
                              
                              Case "FIRER"
                                                            
                              _3DGFXOBJECT(_obj.l)\worldFTileMoveH=1
                              _3DGFXOBJECT(_obj.l)\worldFTileMoveV=0
                              
                              EndSelect      
                                 
                                 
                     EndIf  ;is in screen    - important becaus it is used as timing riddle                                                          
                                                    
                     
                    Case "WATERMIRROR"
                    
                    If _3DGFXOBJECT(_j.l)\worldFTileIsInScreen<>0  ;emit if is in screen!!!!
                        __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                        _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1  
                        
                        
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f+Random(_3DGFXOBJECT(_j.l)\worldFTileW)
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f+Random(_3DGFXOBJECT(_j.l)\worldFTileH)
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                        ; _3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                         _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
                                                                                   
                    EndIf 
              
              
                    Case "VIRUSBLOOD"
                   
                        __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                        _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1  
                        _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f+_3DGFXOBJECT(_j.l)\worldFTileH
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                        ; _3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                          _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
                         __PLAY_ACTION_SOUND(_obj.l,1,1)     
                        
                         
                    Case "GREENACID"
                   
                        __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                        _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1  
                        _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f+_3DGFXOBJECT(_j.l)\worldFTileH
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                        ; _3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                          _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
                         __PLAY_ACTION_SOUND(_obj.l,1,1)     
                                                
                           
              
              
                   Case "DEFAULTBULLET"
                   
                   
                        If _inventory(#fuel)\InventoryObjectSize>0  ;is there ammo?
                         __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                         
                         _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1       
                        
                                     
                         Select  _3DGFXOBJECT(_j.l)\actualDirection
                         
                         Case #MOVE_DOWN
                         
                         _3DGFXOBJECT(_obj.l)\worldFTileMoveH=0
                         _3DGFXOBJECT(_obj.l)\worldFTileMoveV=1
                         _3DGFXOBJECT(_obj.l)\actualDirection=#MOVE_DOWN
                         
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f+_3DGFXOBJECT(_j.l)\worldFTileH
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                        ; _3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                         __PLAY_ACTION_SOUND(_obj.l,1,1)
                         
                         Case #MOVE_UP
                         
                         _3DGFXOBJECT(_obj.l)\worldFTileMoveH=0
                         _3DGFXOBJECT(_obj.l)\worldFTileMoveV=-1
                         _3DGFXOBJECT(_obj.l)\actualDirection=#MOVE_UP
                         
                         
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ;_3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                         __PLAY_ACTION_SOUND(_obj.l,1,1)
                                                  
                         Case #MOVE_LEFT
                         
                         _3DGFXOBJECT(_obj.l)\worldFTileMoveH=-1
                         _3DGFXOBJECT(_obj.l)\worldFTileMoveV=0
                         _3DGFXOBJECT(_obj.l)\actualDirection=#MOVE_LEFT
                         
                         
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ; _3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                         __PLAY_ACTION_SOUND(_obj.l,1,1)
                         
                         
                         Case #MOVE_RIGHT
                         
                         _3DGFXOBJECT(_obj.l)\worldFTileMoveH=1
                         _3DGFXOBJECT(_obj.l)\worldFTileMoveV=0
                         _3DGFXOBJECT(_obj.l)\actualDirection=#MOVE_RIGHT
                         
                         
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f+_3DGFXOBJECT(_j.l)\worldFTileW
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ;_3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                         __PLAY_ACTION_SOUND(_obj.l,1,1)
                         
                         EndSelect
                         
                         EndIf
;                         
                    Case "FLAMME"
                    
                     
                    
                        __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                    
                         _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1    
                     
                        _3DGFXOBJECT(_obj.l)\worldFH=_3DGFXOBJECT(_j.l)\worldFH+_3DGFXOBJECT(_j.l)\worldFTileW/2-_3DGFXOBJECT(_obj.l)\worldFTileW/2 ;fire coord = center of fire object
                         _3DGFXOBJECT(_obj.l)\worldFV=_3DGFXOBJECT(_j.l)\worldFV+_3DGFXOBJECT(_j.l)\worldFTileH/2-_3DGFXOBJECT(_obj.l)\worldFTileH/2
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ;_3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                          _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
                         
                  
                         
                  Case "RADIATION"
                          
                  If _3DGFXOBJECT(_j.l)\worldFTileIsInScreen<>0  ;emit if is in screen!!!!  
                  
                        __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                    
                         _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1    
                     
                        _3DGFXOBJECT(_obj.l)\worldFH=_3DGFXOBJECT(_j.l)\worldFH ;fire coord = center of fire object
                         _3DGFXOBJECT(_obj.l)\worldFV=_3DGFXOBJECT(_j.l)\worldFV
                         ;_3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ;_3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                          _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            

                 EndIf

      
                    
                    Case "FUNKE"
                    
                        __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                  
                         _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1    
                         _3DGFXOBJECT(_obj.l)\worldFH=_3DGFXOBJECT(_j.l)\worldFH+_3DGFXOBJECT(_j.l)\worldFTileW/2-_3DGFXOBJECT(_obj.l)\worldFTileW/2 ;fire coord = center of fire object
                         _3DGFXOBJECT(_obj.l)\worldFV=_3DGFXOBJECT(_j.l)\worldFV+_3DGFXOBJECT(_j.l)\worldFTileH/2-_3DGFXOBJECT(_obj.l)\worldFTileH/2
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ;_3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
;                          _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
;                          _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                        _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            

      
                    Case "LAUBBLATT"
                    
                    
                    If _3DGFXOBJECT(_j.l)\worldFTileIsInScreen<>0  ;emit if is in screen!!!!
                         __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                  
                         _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1    
                         _3DGFXOBJECT(_obj.l)\worldFH=_3DGFXOBJECT(_PLAYER_ID.l)\worldFH
                         _3DGFXOBJECT(_obj.l)\worldFV=_3DGFXOBJECT(_PLAYER_ID.l)\worldFV
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ;_3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
;                          _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
;                          _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                        _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
              EndIf
                                          
                         
                         
                         Case "BURNEDZOMBIE"
                     
                         __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                         _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1    
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ;_3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                         _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
                          __PLAY_ACTION_SOUND(_obj.l,1,1)
                          
                          Case "EXPLODEDGASTANK"
                         __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                         _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1   
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ;_3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                         _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
                          __PLAY_ACTION_SOUND(_obj.l,1,1)
                          
                                                 
                        Default
                        ;for all basic objects used for making level/map "alive"
                    
                        If _3DGFXOBJECT(_obj.l)\worldFTilePlayerID=0
                         __GET_DNA(_3DGFXOBJECT(_obj.l)\worldFTileDNAFile,_obj.l,0)
                         _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1    
                         _3DGFXOBJECT(_obj.l)\worldFH=_src_h.f
                         _3DGFXOBJECT(_obj.l)\worldFV=_src_v.f
                         _3DGFXOBJECT(_obj.l)\usedBy=_j.l;emitted object is used by emitter object
                         ;_3DGFXOBJECT(_j.l)\inUse=_obj.l; emitter is in use
                         _3DGFXOBJECT(_obj.l)\worldFTileW=_3DGFXOBJECT(_obj.l)\worldFTileORIGW
                         _3DGFXOBJECT(_obj.l)\worldFTileH=_3DGFXOBJECT(_obj.l)\worldFTileORIGH
                          _3DGFXOBJECT(_obj.l)\FTileLayer=_3DGFXOBJECT(_j.l)\FTileLayer  ;recreate the layer information,, so make shure it is not lost...                            
                                             
                         
                        EndIf
                    
               EndSelect
               
EndIf 



EndProcedure


Procedure __GET_EMITTEROBJECT_MAP(_obj.l,_src_h.f,_src_v.f)
;here we RESET the values for already used object, so we can use them onece again with the (origin) default values
Define i.l=0

If _max_emitter_object>0

If  _3DGFXOBJECT(_obj.l)\worldFTileIsActive=1

If _3DGFXOBJECT(_obj.l)\worldFTilePlayerID=0 
    
    

    For i.l=0 To _max_emitter_object
    
    If _3DGFXOBJECT(_emitter(i.l))\worldFTileIDString=_3DGFXOBJECT(_obj.l)\useWeapon And _3DGFXOBJECT(_emitter(i.l))\worldFTileIsActive=0
      If Random(_3DGFXOBJECT(_emitter(i.l))\worldFTileRandomActivateWeapon)=0
       __EMIT_OBJECT(_emitter(i.l),_src_h.f,_src_v.f,_obj.l)
     EndIf
      ProcedureReturn
    EndIf  
       
      
    Next
    

    
 EndIf
 
 
 ;for the humancontrolled object:
 
 If _3DGFXOBJECT(_obj.l)\worldFTilePlayerID<>0
 If _3DGFXOBJECT(_obj.l)\button_pressed=#JA_  ;firebutton
    For i.l=0 To _worldftile
    
    If _3DGFXOBJECT(i.l)\worldFTileIDString=_3DGFXOBJECT(_obj.l)\useWeapon And _3DGFXOBJECT(i.l)\worldFTileIsActive=0
           _3DGFXOBJECT(i.l)\worldFTileIsActive=1
           _3DGFXOBJECT(_i.l)\worldFTileIs_GFX=#False ;
          __EMIT_OBJECT(i.l,_src_h.f,_src_v.f,_obj.l)
      
      ProcedureReturn
  
    EndIf
    
    Next
    
 EndIf
 
EndIf
EndIf

EndIf ;any emitter?


EndProcedure









Procedure __GET_EMITTEROBJECT_REGION(_obj.l,_src_h.f,_src_v.f)
;here we RESET the values for already used object, so we can use them onece again with the (origin) default values
;__GET_EMITTEROBJECT_REGION(_d,_3DGFXOBJECT(_d)\worldFH,_3DGFXOBJECT(_d)\worldFV)
Define i.l=0


If _3DGFXOBJECT(_obj.l)\worldFTilePlayerID=0
    For i.l=0 To _worldftile
    
    If _3DGFXOBJECT(i.l)\worldFTileIDString=_3DGFXOBJECT(_obj.l)\useWeapon And _3DGFXOBJECT(i.l)\worldFTileIsActive=0
    
    If _3DGFXOBJECT(_3DGFXOBJECT(_obj.l)\usedBy)\inUse=0
       __EMIT_OBJECT(i.l,_src_h.f,_src_v.f,_obj.l)
      ;######
      ProcedureReturn
    EndIf  
       
    EndIf
    
    Next
    
 EndIf
 
 
 ;for the humancontrolled object:
 
 If _3DGFXOBJECT(_obj.l)\worldFTilePlayerID<>0
 
   If _3DGFXOBJECT(_obj.l)\button_pressed=#JA_  ;firebutton
    For i.l=0 To _worldftile
    
    If _3DGFXOBJECT(i.l)\worldFTileIDString=_3DGFXOBJECT(_obj.l)\useWeapon And _3DGFXOBJECT(i.l)\worldFTileIsActive=0
    
    If _3DGFXOBJECT(_3DGFXOBJECT(_obj.l)\usedBy)\inUse=0
        
          __EMIT_OBJECT(i.l,_src_h.f,_src_v.f,_obj.l)
             
      ;######
    ProcedureReturn
    EndIf  
       
    EndIf
    
    Next
    
    EndIf
    
 EndIf
    



EndProcedure


Procedure __OBJECT_TIMER(_ii.l)
;objectspecific timer (faster than __GLOBAL_TIMER())

If _3DGFXOBJECT(_ii.l)\worldFTileUseTimer=#True


If (_3DGFXOBJECT(_ii.l)\worldFTileStartTime+_3DGFXOBJECT(_ii.l)\worldFTileTimerMS)<ElapsedMilliseconds()
    ;new timer base:
  _3DGFXOBJECT(_ii.l)\worldFTileStartTime=ElapsedMilliseconds()+_3DGFXOBJECT(_ii.l)\worldFTileTimerMS
  
  _3DGFXOBJECT(_ii.l)\worldFTileLifeTime-1
  
  If _3DGFXOBJECT(_ii.l)\worldFTileLifeTime<1
       
       ;for deadly animations or effects
       Select _3DGFXOBJECT(_ii.l)\worldFTileIDString
       
       Case "WANZE"
       
       ;activate the "deadsection"
       _3DGFXOBJECT(_ii.l)\useWeapon="BURNKAKALAK"
       __GET_EMITTEROBJECT_MAP(_ii.l,_3DGFXOBJECT(_ii.l)\worldFH,_3DGFXOBJECT(_ii.l)\worldFV)
       _3DGFXOBJECT(_ii.l)\useWeapon=""
       



     
         
       EndSelect
  
  
      _3DGFXOBJECT(_ii.l)\worldFTileIsActive=0  ;time is over remove the object from the map
      ;_3DGFXOBJECT(_3DGFXOBJECT(_ii.l)\usedBy)\inUse=0  ;remove it from  the used list if is emitterobhect..
      _3DGFXOBJECT(_ii.l)\usedBy=0
      
      ;__RESET_SIZE(_ii.l)
      
          If _3DGFXOBJECT(_ii.l)\worldFTileExpansionValueH<>0 Or _3DGFXOBJECT(_ii.l)\worldFTileExpansionValueV<>0  ;for expansion objects to set them back to real/startsize
          _3DGFXOBJECT(_ii)\worldFTileH=_3DGFXOBJECT(_ii.l)\maxH
          _3DGFXOBJECT(_ii.l)\worldFTileW=_3DGFXOBJECT(_ii.l)\maxW
          ;some for the timerobjects:
          EndIf

      If IsSound(_3DGFXOBJECT(_ii.l)\worldFTileSoundIndex)
      If _3DGFXOBJECT(_ii.l)\worldFTileIsSound=#True
          StopSound(_3DGFXOBJECT(_ii.l)\worldFTileSoundIndex)
      EndIf
      EndIf
  
  EndIf

EndIf

EndIf


EndProcedure



Procedure __SOUNDFX(_s.l)
; If _actualLEVEL<1000  ;>=1000 =credits/intro/...screens


If _3DGFXOBJECT(_s.l)\worldFTileIsActive=1  ;play sound for in map active object only!

If IsSound(_3DGFXOBJECT(_s.l)\worldFTileSoundIndex)
If _3DGFXOBJECT(_s.l)\worldFTileIsSound=#True And _3DGFXOBJECT(_s.l)\worldFTileIsActive>0;play sound for visible objects only

If _3DGFXOBJECT(_s.l)\worldFTileSoundIsPlaying=#True
If ElapsedMilliseconds()>(_3DGFXOBJECT(_s.l)\worldFTileSoundStartTime+_3DGFXOBJECT(_s.l)\worldFTileSoundDuration) Or _3DGFXOBJECT(_s.l)\worldFTileIsInScreen=0
 StopSound(_3DGFXOBJECT(_s.l)\worldFTileSoundIndex)
_3DGFXOBJECT(_s.l)\worldFTileSoundIsPlaying=#False
EndIf
EndIf


If _3DGFXOBJECT(_s.l)\worldFTileSoundIsPlaying=#False
    If _3DGFXOBJECT(_s.l)\worldFTileIsInScreen=1
     PlaySound(_3DGFXOBJECT(_s.l)\worldFTileSoundIndex,0)  ;for testing
     _3DGFXOBJECT(_s.l)\worldFTileSoundStartTime=ElapsedMilliseconds() ;reset the time for new counter!
    _3DGFXOBJECT(_s.l)\worldFTileSoundIsPlaying=#True
    EndIf  
EndIf


EndIf
EndIf


EndIf



EndProcedure



Procedure __DUMMY_CONTROL(_d)
;name should be changed :-) but  I do not know a better for now....
;here we use some specials for sound-anim/behavier oof object is combined with sound/sound started

Select  _3DGFXOBJECT(_d)\worldFTileIDString

Case "DEFAULTZOMBIE"  ;stop it if it "roars"
_3DGFXOBJECT(_d)\goONX=0
_3DGFXOBJECT(_d)\goONY=0

EndSelect

EndProcedure 

Procedure __EFFECTS(_d)

    
    ;simple flire effect (speed  is driven by object value
      
      If _3DGFXOBJECT(_d)\worldFTileFlire<>0
      
       If Random(_3DGFXOBJECT(_d)\worldFTileFlire)=0
        
        _3DGFXOBJECT(_d)\worldFTileIsActive=0 ;used for special effect handling if set to 0 object is out of the map!!!!
        
        Else
        
        _3DGFXOBJECT(_d)\worldFTileIsActive=1
        
       
       EndIf
      
      EndIf
      
   
       
      


EndProcedure 

Procedure __ANIMCONTROL(_d)

;used for framedetection and framedimensions to sent them to the collsiosnsroutine



 Select _3DGFXOBJECT(_d)\actualDirection
      
      Case #MOVE_RIGHT,#MOVE_LEFT
  
  If _3DGFXOBJECT(_d)\goONX<>0  
  If _3DGFXOBJECT(_d)\worldFTileIsAnim<>0 
   __ANIM_HORIZONTAL(_d)
  EndIf
  EndIf

      Case #MOVE_UP,#MOVE_DOWN
      
      If _3DGFXOBJECT(_d)\goONY<>0
      If _3DGFXOBJECT(_d)\worldFTileIsAnim<>0 
      __ANIM_VERTICAL(_d)  
      EndIf
      EndIf
      
  EndSelect



EndProcedure

Procedure __MOVE_CONTROLLER(_d.l)
            ;here we (re)set/correct the movement values, given by objectdata 
                      Select  _3DGFXOBJECT(_d.l)\worldFTilePlayerMove
                      
                      Case 1   ;horizontal only (left/right)
                      _3DGFXOBJECT(_d.l)\worldFTileMoveV=0
                     
                      
                      Case 2 ;vertical move only (up down)
                      _3DGFXOBJECT(_d.l)\worldFTileMoveH=0
                      
                      Case 3 ;move left only...
                      
                      If _3DGFXOBJECT(_d.l)\worldFTileMoveH>0
                         _3DGFXOBJECT(_d.l)\worldFTileMoveH=0
                      EndIf
                      _3DGFXOBJECT(_d.l)\worldFTileMoveV=0
                                           
                      Case 4 ;move right only...
                      If _3DGFXOBJECT(_d.l)\worldFTileMoveH<0
                         _3DGFXOBJECT(_d.l)\worldFTileMoveH=0
                      EndIf
                      _3DGFXOBJECT(_d.l)\worldFTileMoveV=0
                      
                      Case 5 ;move up only...
                      If _3DGFXOBJECT(_d.l)\worldFTileMoveV>0
                         _3DGFXOBJECT(_d.l)\worldFTileMoveV=0
                      EndIf  
                      _3DGFXOBJECT(_d.l)\worldFTileMoveH=0
                      
                      
                      Case 6 ;move down only...
                      If _3DGFXOBJECT(_d.l)\worldFTileMoveV<0
                         _3DGFXOBJECT(_d.l)\worldFTileMoveV=0
                      EndIf 
                      _3DGFXOBJECT(_d.l)\worldFTileMoveH=0                         
                     Default 
                                                 
                     EndSelect
                     
                     If _3DGFXOBJECT(_d.l)\worldFTileMoveH>0
                     _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_RIGHT
                     EndIf
                     
                      
                     If _3DGFXOBJECT(_d.l)\worldFTileMoveH<0
                     _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_LEFT
                     EndIf
                     
                      
                     If _3DGFXOBJECT(_d.l)\worldFTileMoveV>0
                     _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_DOWN
                     EndIf
                     
                     If _3DGFXOBJECT(_d.l)\worldFTileMoveV<0
                     _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_up
                     EndIf



EndProcedure






Procedure __MOVE_EFFECTS(_d)

;her we do some usefull or not so usefull effects :

EndProcedure

Procedure __MOVE_HORIZONTAL(_d)
 _3DGFXOBJECT(_d)\worldFH+(_3DGFXOBJECT(_d)\worldFTileMoveH*_3DGFXOBJECT(_d)\worldFTileVeloH*_3DGFXOBJECT(_d)\goONX)
 __ANIM_HORIZONTAL(_d)
EndProcedure


Procedure __MOVE_VERTICAL(_d.l)
 _3DGFXOBJECT(_d.l)\worldFV+(_3DGFXOBJECT(_d.l)\worldFTileMoveV*_3DGFXOBJECT(_d.l)\worldFTileVeloV*_3DGFXOBJECT(_d.l)\goONY) 
 __ANIM_VERTICAL(_d.l)
EndProcedure




Procedure __MOVE_OBJECT(_d.l)

;for the animframes:

If _3DGFXOBJECT(_d.l)\worldFTilePlayerID=0  ;engine controlled object
 
  
  
 If _3DGFXOBJECT(_d.l)\worldFTileRandomMove<>0  And _3DGFXOBJECT(_d.l)\worldFTileAllDirections<>0;if its used we need it to use
          
        If Random(_3DGFXOBJECT(_d.l)\worldFTileRandomMove)=0  ;the basic random movesystem:
            
            _3DGFXOBJECT(_d.l)\worldFTileMoveV=0
            _3DGFXOBJECT(_d.l)\worldFTileMoveH=1
            _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_RIGHT
            ProcedureReturn
            
         EndIf      
   
   
   If Random(_3DGFXOBJECT(_d.l)\worldFTileRandomMove)=0  ;the basic random movesystem:
      
      
     
      _3DGFXOBJECT(_d.l)\worldFTileMoveV=1
      _3DGFXOBJECT(_d.l)\worldFTileMoveH=0
      _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_DOWN
      ProcedureReturn
    
        
   EndIf      
   
   
   
   If Random(_3DGFXOBJECT(_d.l)\worldFTileRandomMove)=0  ;the basic random movesystem:
     
     
      _3DGFXOBJECT(_d.l)\worldFTileMoveV=-1
      _3DGFXOBJECT(_d.l)\worldFTileMoveH=0
      _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_UP
      ProcedureReturn
   
        
   EndIf     
   
   
   If Random(_3DGFXOBJECT(_d.l)\worldFTileRandomMove)=0  ;the basic random movesystem:
      
 
      _3DGFXOBJECT(_d.l)\worldFTileMoveV=0
      _3DGFXOBJECT(_d.l)\worldFTileMoveH=-1
      _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_LEFT
      ProcedureReturn
   
        
   EndIf     
   
   
        
   If Random(_3DGFXOBJECT(_d.l)\worldFTileRandomMove)=0  
    
      _3DGFXOBJECT(_d.l)\worldFTileMoveV=0
      _3DGFXOBJECT(_d.l)\worldFTileMoveH=0
      _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_DEFAULT
      ProcedureReturn
    
        
        
  EndIf                           
       
          
 EndIf
        
        If _3DGFXOBJECT(_d.l)\worldFTileMoveV<>0
          __MOVE_VERTICAL(_d)
        EndIf
        
        
        If _3DGFXOBJECT(_d.l)\worldFTileMoveH<>0
          __MOVE_HORIZONTAL(_d)
        EndIf

        
        ;default/waiting:
   
 
 
 EndIf ;engiencontrolled object
 

 
 If _3DGFXOBJECT(_d)\worldFTilePlayerID<>0
              If _3DGFXOBJECT(_d)\worldFTileMoveH<>0
                          __MOVE_HORIZONTAL(_d)  ;playerobject?
              EndIf  
              
              If _3DGFXOBJECT(_d)\worldFTileMoveV<>0        
                          __MOVE_VERTICAL(_d)
              EndIf   
 EndIf
                       
 ;endanimframes 
  __MOVE_EFFECTS(_d)
  EndProcedure


Procedure __TOUCHMOVE_CONTROLLER(_d)
Define r.l=0


r.l=Random(_3DGFXOBJECT(_d.l)\worldFTileTouchMove)

If _3DGFXOBJECT(_d.l)\worldFTileTouchMove=1
r.l=0
EndIf


If r.l=0
If _3DGFXOBJECT(_d.l)\worldFTileDynamicVelo=0  ;if there was no velo at object load we can do it !
If _3DGFXOBJECT(_d.l)\worldFTileVeloH>0.1
_3DGFXOBJECT(_d.l)\worldFTileVeloH*0.9
_3DGFXOBJECT(_d.l)\worldFTileVELO*0.9
EndIf
If _3DGFXOBJECT(_d)\worldFTileMoveV>0.1
_3DGFXOBJECT(_d.l)\worldFTileVeloV*0.9
_3DGFXOBJECT(_d.l)\worldFTileVELO*0.9
EndIf

If _3DGFXOBJECT(_d.l)\worldFTileVeloV<0.1
_3DGFXOBJECT(_d.l)\worldFTileVeloV=0
_3DGFXOBJECT(_d.l)\worldFTileVELO=0
EndIf
If _3DGFXOBJECT(_d.l)\worldFTileVeloH<0.1
_3DGFXOBJECT(_d.l)\worldFTileVeloH=0
_3DGFXOBJECT(_d.l)\worldFTileVELO=0
EndIf
EndIf 
EndIf
EndProcedure

Procedure __GOBACK(_d)
;move objects back To startposition/origin position
;bug: moves total To zero map location?

_3DGFXOBJECT(_d)\worldFTileVeloV=2
_3DGFXOBJECT(_d)\worldFTileVeloH=2

If (_3DGFXOBJECT(_d)\worldFH)<(_3DGFXOBJECT(_d)\worldFTileXPOS)
    _3DGFXOBJECT(_d)\worldFTileMoveH=1
EndIf

If (_3DGFXOBJECT(_d)\worldFH)>(_3DGFXOBJECT(_d)\worldFTileXPOS)
    _3DGFXOBJECT(_d)\worldFTileMoveH=-1
EndIf


If (_3DGFXOBJECT(_d)\worldFV)>(_3DGFXOBJECT(_d)\worldFTileYPOS)
    _3DGFXOBJECT(_d)\worldFTileMoveV=-1
EndIf

If (_3DGFXOBJECT(_d)\worldFV)<(_3DGFXOBJECT(_d)\worldFTileYPOS)
     _3DGFXOBJECT(_d)\worldFTileMoveV=1
EndIf

If Abs(_3DGFXOBJECT(_d)\worldFH-_3DGFXOBJECT(_d)\worldFTileXPOS)<=2
    _3DGFXOBJECT(_d)\worldFTileMoveH=0
EndIf


If Abs(_3DGFXOBJECT(_d)\worldFV-_3DGFXOBJECT(_d)\worldFTileYPOS)<=2
    _3DGFXOBJECT(_d)\worldFTileMoveV=0
EndIf

EndProcedure


Procedure __OBJECT_CONTROLLER(_d)
;check all objects and manage the situation (remove/reanimate/score/gameover...)
;reset object to a valid state, so sgfx can use them once again
       ;reset the touctransparency:
; ;        
       ;_3DGFXOBJECT(_d.l)\goONY=1
       ;_3DGFXOBJECT(_d.l)\goONX=1
   
       If _3DGFXOBJECT(_d)\worldFTileTouchTransparency<>0 And _3DGFXOBJECT(_d)\worldFTileIsInScreen=1
             _3DGFXOBJECT(_d)\worldFTileTransparency=_3DGFXOBJECT(_d)\worldFTileTransparencyBackUp
       EndIf
       
       ;reset/countdown touchrotate:
       
       If _3DGFXOBJECT(_d)\worldFTileTouchrotate<>0
       
        If _3DGFXOBJECT(_d)\worldFTileRotate>0
            _3DGFXOBJECT(_d)\worldFTileRotate-0.05
        EndIf
        
        If _3DGFXOBJECT(_d)\worldFTileRotate<0
            _3DGFXOBJECT(_d)\worldFTileRotate+0.05
        EndIf
       
       EndIf
       
       
       ;object:sound? play it for visible objects only
       
      If Random(_3DGFXOBJECT(_d)\worldFTileRandomSound)=0  ;if value >0 we use random start/restart, if 0 we start/restart sound if sound has stopped)
       
       If _3DGFXOBJECT(_d)\isRotating=1 ;control for rotating objects so we use sound if object rotates, and do not use sound if object does nothing
        If _3DGFXOBJECT(_d)\worldFTileSoundIndex<>0  And _3DGFXOBJECT(_d)\worldFTileSoundPlayOnAction=0 ;stop soundfx if minimap is shown
          ;  If ElapsedMilliseconds()>(_3DGFXOBJECT(_d)\worldFTileSoundDuration+_3DGFXOBJECT(_d)\worldFTileSoundStartTime)  ;is sound played to the end?
                 ;__DUMMY_CONTROL(_d) ;some special behavior  
          If _3DGFXOBJECT(_d)\worldFTileSoundPlayOnAction=0 ;default!!!!!  
          __SOUNDFX(_d)  ;try to play the object sound....
          EndIf
       ;EndIf           
        EndIf
      
       EndIf
       
       If _3DGFXOBJECT(_d)\worldFTilePlaySoundOnView
       __SOUNDFX(_d)
       EndIf
       
   EndIf ;sound....    
       
                 

EndProcedure




Procedure __ACTIONSELECTOR(_a.l,_b.l)
;get the objects:

;_a=active test object, _b=passive testobject (_a does collission with _b)

;for npc

If _3DGFXOBJECT(_b.l)\worldFTileTouchMove<>0

        __TOUCHMOVE(_a.l,_b.l)
        

EndIf



;autotransport tiles:
If _3DGFXOBJECT(_b.l)\worldFTileTransport<>0
     TRANSPORT(_a.l,_b.l)  ;ACTIONS_SHEED (ACTIONS.pbi)
EndIf

;touchtransparency:

If _3DGFXOBJECT(_b.l)\worldFTileTouchTransparency<>0  And _3DGFXOBJECT(_a.l)\worldFTileVELO<>0 And _b.l<>_a.l
      Select _3DGFXOBJECT(_a.l)\worldFTileIDString
      Case "LIGHTBLUE"
      ;nope!
      Default
       _3DGFXOBJECT(_b.l)\worldFTileTransparency=_3DGFXOBJECT(_b.l)\worldFTileTouchTransparency  ;make passive object "transparent" for special use (woods,buildings...)to keep the object visible 
      EndSelect
EndIf
;touchrotate:

If _3DGFXOBJECT(_b.l)\worldFTileTouchRotate<>0  And _3DGFXOBJECT(_a.l)\worldFTileVELO<>0
 
  _3DGFXOBJECT(_b.l)\worldFTileRotate+(_3DGFXOBJECT(_a.l)\worldFTileMoveH+_3DGFXOBJECT(_a.l)\worldFTileMoveV)/10
  
  If _3DGFXOBJECT(_b.l)\worldFTileRotate>1
    _3DGFXOBJECT(_b.l)\worldFTileRotate=1
  EndIf
  If _3DGFXOBJECT(_b.l)\worldFTileRotate<-1
    _3DGFXOBJECT(_b.l)\worldFTileRotate=-1
  EndIf
  
EndIf

;here we call the object procedures (objects with collision, (a)active + (b)passive)

Select _3DGFXOBJECT(_a.l)\worldFTileIDString


Case "DEFAULTBULLET"
DEFAULTBULLET(_a.l,_b.l)

Case "BASKET"
BASKET(_a.l,_b.l)

Case "FLAMME"
FLAMME(_a.l,_b.l)

Case "DEFAULTZOMBIE"
DEFAULTZOMBIE(_a.l,_b.l)


Case "FUNKE"
FUNKE(_a.l,_b.l)

Case "REDVIRUS"
REDVIRUS(_a.l,_b.l)

Case "HELMET"
HELMET(_a.l,_b.l)


Case "BASEWANZE"
BASEWANZE(_a.l,_b.l)

Case "GREENACID"
ACID(_a.l,_b.l)


Case "DEKO"
CRAPS(_a.l,_b.l)

Case "CRAPS"
CRAPS(_a.l,_b.l)

Case "GREENPLANT"
GREENPLANT(_a.l,_b.l)

Case "MONEY","HP+"
AUTOMOVE_GOODIES(_a.l,_b.l)


Case "REDFIRE"
REDFIRE(_a.l,_b.l)


;   
;   Case "REDFIRE","BLUEFIRE","GREENFIRE"
;   FIREWORKS(_a.l,_b.l)
  
  Default
  ;for the player/user we need a different action system, because the engine can handle up to +255 playerobjects and up to -255 playerobjects (total 510)

If _3DGFXOBJECT(_a.l)\worldFTilePlayerID<>0
    PLAYER(_a.l,_b.l)
    
    Else   ;the alternative move direction for the enemies/local objects...if colided with env
  
If Random(10)=5 
      _3DGFXOBJECT(_a.l)\worldFTileMoveH*-1
EndIf  

If Random(10)=1 
     _3DGFXOBJECT(_a.l)\worldFTileMoveV*-1
EndIf  
    
EndIf

EndSelect


EndProcedure




Procedure __OBJECT_OBJECT_COLLISION(_dest_x1,_dest_y1,w1,h1,_dest_x2,_dest_y2,w2,h2,_i.l,_e.l,_o1$,_o2$)

Define _colli.b=0
          
          If _dest_x1<(_dest_x2+w2) And _dest_x1>_dest_x2 And _dest_y1<(_dest_y2+h2) And _dest_y1>_dest_y2
           _colli.b=1
           If _3DGFXOBJECT(_i.l)\worldFTileMoveH<>0 And _3DGFXOBJECT(_i.l)\goONX<>0 
             _3DGFXOBJECT(_i.l)\goONX=0 ;default setting on collision
           
           EndIf
          EndIf
          
          If (_dest_x1+w1)>_dest_x2 And (_dest_x1+w1)<(_dest_x2+w2) And (_dest_y1+h1)>_dest_y2 And (_dest_y1+h1)<(_dest_y2+h2)
          _colli.b=1
          If _3DGFXOBJECT(_i.l)\worldFTileMoveH<>0 And _3DGFXOBJECT(_i.l)\goONX<>0 
          _3DGFXOBJECT(_i.l)\goONX=0 ;default setting on collision
       
          EndIf
          EndIf
          
          
          If _dest_y1<(_dest_y2+h2) And (_dest_y1+h1)>_dest_y2 And _dest_x1<(_dest_x2+w2) And (_dest_x1+w1)>_dest_x2
           _colli.b=1
           If _3DGFXOBJECT(_i.l)\worldFTileMoveV<>0 And _3DGFXOBJECT(_i.l)\goONY<>0
          _3DGFXOBJECT(_i.l)\goONY=0
        
         EndIf
          EndIf
          
          If (_dest_y1+h1)>_dest_y2 And _dest_y1<(_dest_y2+h2) And (_dest_x1+w1)>_dest_x2 And (_dest_x1+w1)<(_dest_x2+w2)
          _colli.b=1
          If _3DGFXOBJECT(_i.l)\worldFTileMoveV<>0 And _3DGFXOBJECT(_i.l)\goONY<>0
          _3DGFXOBJECT(_i.l)\goONY=0
          
         EndIf
          EndIf
          
          If _colli.b<>0
            __ACTIONSELECTOR(_i.l,_e.l)
          EndIf


EndProcedure




Procedure __AREA_COLLISION_DETECTION_REGION(_d.l)

Define x1.f=0,y1.f=0,w1.f=0,h1.f=0,x2.f=0,y2.f=0,w2.f=0,h2.f=0 ;object dimensions
Define dest_x1.f=0,dest_y1.f=0,dest_x2.f=0,dest_y2.f=0
;check if it is active:

      x1.f=_3DGFXOBJECT(_d.l)\worldFH
      y1.f=_3DGFXOBJECT(_d.l)\worldFV
      w1.f=_3DGFXOBJECT(_d.l)\maxW
      h1.f=_3DGFXOBJECT(_d.l)\maxH
      dest_x1.f=_3DGFXOBJECT(_d.l)\worldFH+(_3DGFXOBJECT(_d.l)\worldFTileMoveH*_3DGFXOBJECT(_d.l)\worldFTileVeloH);*_3DGFXOBJECT(_d.l)\goONX)
      dest_y1.f=_3DGFXOBJECT(_d.l)\worldFV+(_3DGFXOBJECT(_d.l)\worldFTileMoveV*_3DGFXOBJECT(_d.l)\worldFTileVeloV);*_3DGFXOBJECT(_d.l)\goONY)     


      For _i.l=0 To _max_lucy
     
     
     ;region  check:
        
   If _3DGFXOBJECT(_lucy(_i.l))\worldFTileIsInScreen=1                  


      If _lucy(_i.l)<>_d.l  And _3DGFXOBJECT(_lucy(_i.l))\worldFTileIsActive=1 And _3DGFXOBJECT(_lucy(_i.l))\worldFTileCollision<>0 
           
            x2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFH
            y2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFV
            w2.f=_3DGFXOBJECT(_lucy(_i.l))\maxW
            h2.f=_3DGFXOBJECT(_lucy(_i.l))\maxH
            
             dest_x2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFH+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveH*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloH);*_3DGFXOBJECT(_lucy(_i.l))\goONX)
              dest_y2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFV+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveV*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloV);*_3DGFXOBJECT(_lucy(_i.l))\goONY)
        
                          dest_y2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFV+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveV*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloV*_3DGFXOBJECT(_lucy(_i.l))\goONY)
          
        ;call the relevant routine!
              
            __OBJECT_OBJECT_COLLISION(dest_x1,dest_y1,w1,h1,dest_x2,dest_y2,w2,h2,_d.l,_lucy(_i.l),_3DGFXOBJECT(_d.l)\worldFTileIDString,_3DGFXOBJECT(_lucy(_i.l))\worldFTileIDString) 

      EndIf
      
      EndIf     ;is in screen?  
       
   
   ;end region version
   
  Next






EndProcedure








Procedure __DEFAULT_COLLISION_DETECTION_MAP(_d.l)

Define x1.f=0,y1.f=0,w1.f=0,h1.f=0,x2.f=0,y2.f=0,w2.f=0,h2.f=0 ;object dimensions
Define dest_x1.f=0,dest_y1.f=0,dest_x2.f=0,dest_y2.f=0
;check if it is active:

      x1.f=_3DGFXOBJECT(_d.l)\worldFH
      y1.f=_3DGFXOBJECT(_d.l)\worldFV
      w1.f=_3DGFXOBJECT(_d.l)\worldFTileW
      h1.f=_3DGFXOBJECT(_d.l)\worldFTileH
      dest_x1.f=_3DGFXOBJECT(_d.l)\worldFH+(_3DGFXOBJECT(_d.l)\worldFTileMoveH*_3DGFXOBJECT(_d.l)\worldFTileVeloH);*_3DGFXOBJECT(_d.l)\goONX)
      dest_y1.f=_3DGFXOBJECT(_d.l)\worldFV+(_3DGFXOBJECT(_d.l)\worldFTileMoveV*_3DGFXOBJECT(_d.l)\worldFTileVeloV);*_3DGFXOBJECT(_d.l)\goONY)     


  For _i.l=0 To _max_lucy
     
     
     ;region  check:

      If _lucy(_i.l)<>_d.l  And _3DGFXOBJECT(_lucy(_i.l))\worldFTileIsActive=1 And _3DGFXOBJECT(_lucy(_i.l))\worldFTileCollision<>0 
  
            x2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFH
            y2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFV
            w2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFTileW
            h2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFTileH
           
              dest_x2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFH+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveH*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloH);*_3DGFXOBJECT(_lucy(_i.l))\goONX)
              dest_y2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFV+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveV*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloV);*_3DGFXOBJECT(_lucy(_i.l))\goONY)
             
         
                     dest_x2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFH+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveH*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloH*_3DGFXOBJECT(_lucy(_i.l))\goONX)
           
                          dest_y2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFV+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveV*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloV*_3DGFXOBJECT(_lucy(_i.l))\goONY)
    
              
            __OBJECT_OBJECT_COLLISION(dest_x1,dest_y1,w1,h1,dest_x2,dest_y2,w2,h2,_d.l,_lucy(_i.l),_3DGFXOBJECT(_d.l)\worldFTileIDString,_3DGFXOBJECT(_lucy(_i.l))\worldFTileIDString) 

      EndIf
      
   
       
   
   ;end region version
   
  Next


EndProcedure




Procedure __DEFAULT_COLLISION_DETECTION_REGION(_d.l)

Define x1.f=0,y1.f=0,w1.f=0,h1.f=0,x2.f=0,y2.f=0,w2.f=0,h2.f=0 ;object dimensions
Define dest_x1.f=0,dest_y1.f=0,dest_x2.f=0,dest_y2.f=0
;check if it is active:

      x1.f=_3DGFXOBJECT(_d.l)\worldFH
      y1.f=_3DGFXOBJECT(_d.l)\worldFV
      w1.f=_3DGFXOBJECT(_d.l)\worldFTileW
      h1.f=_3DGFXOBJECT(_d.l)\worldFTileH
      dest_x1.f=_3DGFXOBJECT(_d.l)\worldFH+(_3DGFXOBJECT(_d.l)\worldFTileMoveH*_3DGFXOBJECT(_d.l)\worldFTileVeloH);*_3DGFXOBJECT(_d.l)\goONX)
      dest_y1.f=_3DGFXOBJECT(_d.l)\worldFV+(_3DGFXOBJECT(_d.l)\worldFTileMoveV*_3DGFXOBJECT(_d.l)\worldFTileVeloV);*_3DGFXOBJECT(_d.l)\goONY)     


  For _i.l=0 To _max_lucy
     
     
     ;region  check:
        
   If _3DGFXOBJECT(_lucy(_i.l))\worldFTileIsInScreen=1                  

      If _lucy(_i.l)<>_d.l  And _3DGFXOBJECT(_lucy(_i.l))\worldFTileIsActive=1 And _3DGFXOBJECT(_lucy(_i.l))\worldFTileCollision<>0 
  
            x2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFH
            y2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFV
            w2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFTileW
            h2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFTileH
           
              dest_x2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFH+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveH*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloH);*_3DGFXOBJECT(_lucy(_i.l))\goONX)
              dest_y2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFV+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveV*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloV);*_3DGFXOBJECT(_lucy(_i.l))\goONY)
             
       
                     dest_x2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFH+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveH*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloH*_3DGFXOBJECT(_lucy(_i.l))\goONX)
            
                          dest_y2.f=_3DGFXOBJECT(_lucy(_i.l))\worldFV+(_3DGFXOBJECT(_lucy(_i.l))\worldFTileMoveV*_3DGFXOBJECT(_lucy(_i.l))\worldFTileVeloV*_3DGFXOBJECT(_lucy(_i.l))\goONY)
     
        ;call the relevant routine!
              
            __OBJECT_OBJECT_COLLISION(dest_x1,dest_y1,w1,h1,dest_x2,dest_y2,w2,h2,_d.l,_lucy(_i.l),_3DGFXOBJECT(_d.l)\worldFTileIDString,_3DGFXOBJECT(_lucy(_i.l))\worldFTileIDString) 

      EndIf
      
      EndIf     ;is in screen?  
       
   
   ;end region version
   
  Next


EndProcedure





Procedure __OTHER_CONTROL(_d)
If _3DGFXOBJECT(_d.l)\worldFTileIsActive<>-1  ;-1 is killed from the engine, removed from map....
__EFFECTS(_d)  ;call some special actions 
EndIf
EndProcedure


Procedure __SCROLL_MAPH(_d)
Define _iii.l=0

      
      If _3DGFXOBJECT(_d)\goONX<>0 And _3DGFXOBJECT(_d.l)\worldFTileMoveH<>0
;       _accu_x.l-_3DGFXOBJECT(_d.l)\worldFTileMoveH*_3DGFXOBJECT(_d.l)\worldFTileVeloH
      For _iii.l=0 To _worldftile
      If _iii.l<>_d.l And _3DGFXOBJECT(_iii.l)\worldFTileIsGUI=0
      If _3DGFXOBJECT(_iii.l)\worldFTileNoScroll=0
       _3DGFXOBJECT(_iii.l)\worldFH-(_3DGFXOBJECT(_d.l)\worldFTileMoveH*_3DGFXOBJECT(_d.l)\worldFTileVeloH)
      EndIf
      EndIf
      Next 
      EndIf
      
      _3DGFXOBJECT(_d.l)\worldFH-(_3DGFXOBJECT(_d.l)\worldFTileMoveH*_3DGFXOBJECT(_d.l)\worldFTileVeloH)

EndProcedure


Procedure __SCROLL_MAPV(_d)
Define _iii.l=0


;height of map

     
      If _3DGFXOBJECT(_d)\goONY<>0 And _3DGFXOBJECT(_d.l)\worldFTileMoveV<>0
;        _accu_y.l-(_3DGFXOBJECT(_d.l)\worldFTileMoveV*_3DGFXOBJECT(_d.l)\worldFTileVeloV)
      For _iii.l=0 To _worldftile
      If _iii.l<>_d.l And _3DGFXOBJECT(_iii.l)\worldFTileIsGUI=0
      If _3DGFXOBJECT(_iii.l)\worldFTileNoScroll=0
       _3DGFXOBJECT(_iii.l)\worldFV-(_3DGFXOBJECT(_d.l)\worldFTileMoveV*_3DGFXOBJECT(_d.l)\worldFTileVeloV)
      EndIf
      EndIf
      Next 
      EndIf
      
      _3DGFXOBJECT(_d.l)\worldFV-(_3DGFXOBJECT(_d.l)\worldFTileMoveV*_3DGFXOBJECT(_d.l)\worldFTileVeloV)


EndProcedure





Procedure __DYNAMICSCROLL(_d)

;       If _3DGFXOBJECT(_d)\worldFH>_screen_w.f/2  ;central controlled for now (developement) will be changed to a semidynamicaly selection
;       __SCROLL_MATRIX(_d)
;       EndIf
;       
;       If _3DGFXOBJECT(_d)\worldFH<_screen_w.f/2
;       __SCROLL_MATRIX(_d)
;       EndIf
;       
;       
;       If _3DGFXOBJECT(_d)\worldFV>_screen_h.f/2
;       __SCROLL_MATRIX(_d)
;       EndIf
;       

  If _3DGFXOBJECT(_d)\goONX<>0
  If _3DGFXOBJECT(_d)\worldFH>_screen_w.f*0.7 Or  _3DGFXOBJECT(_d)\worldFH<_screen_w.f*0.3
      __SCROLL_MAPH(_d)
  EndIf
  EndIf
  
  If _3DGFXOBJECT(_d)\goONY<>0
  If _3DGFXOBJECT(_d)\worldFV>_screen_h.f*0.7 Or  _3DGFXOBJECT(_d)\worldFV<_screen_h.f*0.3 
      __SCROLL_MAPV(_d)
  EndIf
  EndIf
  
  
EndProcedure


Procedure __PLAYER_MOUSE(_d)
_3DGFXOBJECT(_d)\worldFH=MouseX()
_3DGFXOBJECT(_d)\worldFV=MouseY()
EndProcedure



Procedure __PLAYER_KEYBOARD(_d)

  _3DGFXOBJECT(_d)\worldFTileMoveH=0
  _3DGFXOBJECT(_d)\worldFTileMoveV=0
  _3DGFXOBJECT(_d)\button_pressed=0 ;reset!!!!
If _3DGFXOBJECT(_d)\worldFTileIsActive=1  ;default value if object is usable!

                      If KeyboardPushed(#PB_Key_Left) 
                      _3DGFXOBJECT(_d)\worldFTileMoveH=-1
                      EndIf
                      
                      
                      If KeyboardPushed(#PB_Key_Right) 
                        _3DGFXOBJECT(_d)\worldFTileMoveH=1
                      EndIf
                      
                      
                      
                      If KeyboardPushed(#PB_Key_Up) 
                         _3DGFXOBJECT(_d)\worldFTileMoveV=-1
                      EndIf
                      
                      
                      If KeyboardPushed(#PB_Key_Down) 
                       _3DGFXOBJECT(_d)\worldFTileMoveV=1
                      EndIf
                      
                      
                      If KeyboardPushed(#PB_Key_Space)
                      _3DGFXOBJECT(_d)\button_pressed=#JA_
                     EndIf
                      
                                          
                      
                      
                      __MOVE_CONTROLLER(_d)

EndIf


EndProcedure

Procedure __PLAYER_JOYPAD(_d)
Define  _a.l=0

_3DGFXOBJECT(_d)\button_pressed=-1  ;reset the buttonstate!!!!
_3DGFXOBJECT(_d)\worldFTileMoveH=JoystickAxisX()
_3DGFXOBJECT(_d)\worldFTileMoveV=JoystickAxisY()
__MOVE_CONTROLLER(_d)

For _button.b=1 To 10
    
    If JoystickButton(_button.b)
      _3DGFXOBJECT(_d)\button_pressed=_button.b
      ProcedureReturn  ;try a fast exit if any button is pressed...
    EndIf   
;
        
Next
; 
; If _a.l=0 And _3DGFXOBJECT(_d)\button_pressed=#JA_
; _3DGFXOBJECT(_d)\button_pressed=0
; EndIf

EndProcedure



; Procedure __TOUCH(_d)
; 
; EndProcedure
; 

Procedure __USER_IO(_d)
;new!!! integrated with version 02042012

Select _use_input_device


Case #KEYBOARD_
__PLAYER_KEYBOARD(_d)

Case #JOYPAD_

__PLAYER_JOYPAD(_d)

EndSelect


EndProcedure



Procedure __PLAYER_CONTROL(_d)
;new version (02.04.12) = 02042012
Define _io.l=-1  ;nothing!

      If _3DGFXOBJECT(_d)\worldFTileUseKeyboard<>0
      ;__PLAYER_KEYBOARD(_d)
      _use_input_device=#KEYBOARD_
      ExamineKeyboard()
      __USER_IO(_d)
      EndIf
      
      If _3DGFXOBJECT(_d)\worldFTileUseStick<>0 And _joy_pad.b=#True
      ;__PLAYER_JOYPAD(_d)
      _use_input_device=#JOYPAD_
      ExamineJoystick()
      __USER_IO(_d)
      Else
      _use_input_device=#KEYBOARD_   ;fall back...
      ExamineKeyboard()
      __USER_IO(_d)
;       
      EndIf
      
      If _3DGFXOBJECT(_d)\worldFTileIsHWMousePointer<>0
      ;__PLAYER_MOUSE(_d)
      ExamineMouse()
      __USER_IO(_d)
      EndIf

EndProcedure



Procedure __POSTEFFECT(_effect$)
 Define part1$="":Define part2$:Define dummy=0

dummy=FindString(_effect$,"x",0)
part1$=Mid(_effect$,0,dummy-1)
part2$=Mid(_effect$,dummy+1,Len(_effect$))

        If part1$<>"" And part2$<>""
        _dx1.b=Val(part1$)
        _dx2.b=Val(part2$)
        Else
        _dx1.b=0
        _dx2.b=0
        EndIf 

EndProcedure

Procedure __LUCY_SUPEROTATE(SpriteID, SWidth.f, SHeight.f, SAngle.f, SxShift.f, SyShift.f)
Define SpriteID:Define SWidth.f: Define SHeight.f: Define SAngle.f: Define  SxShift.f: Define SyShift.f
Define xShift.f: Define yShift.f
  Protected r.f = Sqr(SWidth*SWidth+SHeight*SHeight)/2 ; Radius
  Protected t.f = ATan(SWidth/SHeight) ; Tau
  Protected a1.f = SAngle.f       - t
  Protected a2.f = SAngle.f       + t
  Protected a3.f = SAngle.f + #PI - t
  Protected a4.f = SAngle.f + #PI + t
   xShift.f=SWidth.f/2
   yShift.f=SHeight.f/2
   
   If _3DGFXOBJECT(SpriteID)\worldFTileIs_GFX=#True
   If Random(_3DGFXOBJECT(SpriteID)\worldFTileRandomRotate)=0 ;if value>0 we do not rotate, default value=0 or changed by DNA
      _3DGFXOBJECT(SpriteID)\isRotating=1 
      _3DGFXOBJECT(SpriteID)\worldFTileAngle+_3DGFXOBJECT(SpriteID)\worldFTileRotate
      TransformSprite3D(_3DGFXOBJECT(SpriteID)\worldFTileGFX, Cos(a1)*r+xShift.f, Sin(a1)*r+yShift.f, Cos(a2)*r+xShift.f, Sin(a2)*r+yShift.f, Cos(a3)*r+xShift.f, Sin(a3)*r+yShift.f, Cos(a4)*r+xShift.f, Sin(a4)*r+yShift.f)
  Else
  _3DGFXOBJECT(SpriteID)\isRotating=0 ;for the rotating soundsystem!
  EndIf
  EndIf
   xShift.f=0
   yShift.f=0
   
 EndProcedure
 
 
 Procedure __DO_FOLLOW(_o1.l,_d)
 
 ;_o1=bassive, _d=active
 
 If _3DGFXOBJECT(_d.l)\AI=0  ;AI for object is on
 
 If _3DGFXOBJECT(_d.l)\worldFTileMoveH<>0  ;move if move is on!
 
      If  _3DGFXOBJECT(_d.l)\worldFTileCenterX<_3DGFXOBJECT(_o1.l)\worldFTileCenterX
      
        _3DGFXOBJECT(_d.l)\worldFTileMoveH=1
      
      EndIf
   
       If   _3DGFXOBJECT(_d.l)\worldFTileCenterX>_3DGFXOBJECT(_o1.l)\worldFTileCenterX
      
        _3DGFXOBJECT(_d.l)\worldFTileMoveH=-1
      
      EndIf
 
 EndIf
 
 If _3DGFXOBJECT(_d.l)\worldFTileMoveV<>0 ;move if move is on!
       If  _3DGFXOBJECT(_d.l)\worldFTileCenterY<_3DGFXOBJECT(_o1.l)\worldFTileCenterY
         _3DGFXOBJECT(_d.l)\worldFTileMoveV=1
      EndIf
      
      
       If  _3DGFXOBJECT(_d.l)\worldFTileCenterY>_3DGFXOBJECT(_o1.l)\worldFTileCenterY
              _3DGFXOBJECT(_d.l)\worldFTileMoveV=-1
       EndIf
 
 EndIf

 EndIf
 
 ;this is used for "intelligent follow system (if value <0 object will "flee" from object to follow)...
 _3DGFXOBJECT(_d.l)\worldFTileMoveH=_3DGFXOBJECT(_d.l)\worldFTileMoveH*_3DGFXOBJECT(_d.l)\worldFTileFollowObject
 _3DGFXOBJECT(_d.l)\worldFTileMoveV=_3DGFXOBJECT(_d.l)\worldFTileMoveV*_3DGFXOBJECT(_d.l)\worldFTileFollowObject
 
 EndProcedure
 
   ;new experimental
 Procedure  __FOLLOWOBJECT_MAP(_id$,_d.l) 
Define _object1.l=0  ;we use this for following objects one object-check/frame so we can gain speed and engine does not  "stop" while searching for object to follow


; If _3DGFXOBJECT(_d.l)\worldFTileInTouch=1    ;we use the followfunction if object was once in screen  
 If      _3DGFXOBJECT(_d.l)\worldFTileDestinationID=0  ;if no destination object id is stored...

        For _object1.l=0 To _worldftile
        If _3DGFXOBJECT(_object1.l)\worldFTileIsInScreen=1  ;special for region, follow find objects in screen /visible area only
        If _3DGFXOBJECT(_object1.l)\worldFTileIDString=_id$  ;we got it!
        If _3DGFXOBJECT(_object1.l)\worldFTileIsActive<>0
           _3DGFXOBJECT(_d.l)\worldFTileDestinationID=_object1
          __DO_FOLLOW(_object1.l,_d)  ;ID1, _d=follower
          _object1.l=_worldftile
        EndIf
        EndIf
        EndIf
        Next
        
        Else
        ;we already got the the object to follow
       __DO_FOLLOW(_3DGFXOBJECT(_d.l)\worldFTileDestinationID,_d.l)  ;ID1, _d=follower

 
  EndIf 
 ;EndIf
  
  
  EndProcedure
  
  ;new experimental
  Procedure  __FOLLOWOBJECT_REGION(_id$,_d) 
;used for games whre action is in visible area only
Define _object1.l=0  ;we use this for following objects one object-check/frame so we can gain speed and engine does not  "stop" while searching for object to follow
  
  If      _3DGFXOBJECT(_d.l)\worldFTileDestinationID<1  ;if no destination object id is stored...

        For _object1.l=0 To _worldftile
        If _3DGFXOBJECT(_object1.l)\worldFTileIsInScreen=1  ;special for region, follow find objects in screen /visible area only
        If _3DGFXOBJECT(_object1.l)\worldFTileIDString=_id$  ;we got it!
        If _3DGFXOBJECT(_object1.l)\worldFTileIsActive>0
           _3DGFXOBJECT(_d.l)\worldFTileDestinationID=_object1
          __DO_FOLLOW(_object1.l,_d)  ;ID1, _d=follower
          _object1.l=_worldftile
        EndIf
        EndIf
        EndIf
        Next
        
        Else
        ;we already got the the object to follow
       __DO_FOLLOW(_3DGFXOBJECT(_d.l)\worldFTileDestinationID,_d)  ;ID1, _d=follower

 
  EndIf 
  
  EndProcedure
 




Procedure __OBJECT_MANAGER_MAP(_d)


   ;expand?/zoomsystem?
   
   If _3DGFXOBJECT(_d.l)\worldFTileIsActive>0  ;is active, we can use it in engine, 0 = out of engine we do NOT use this object anymore
   
   If _3DGFXOBJECT(_d)\worldFTileExpansionValueH<>0 Or _3DGFXOBJECT(_d)\worldFTileExpansionValueV<>0
         __EXPANSION(_d)
   EndIf
   
   If _3DGFXOBJECT(_d)\worldFTileTouchMove<>0 And _3DGFXOBJECT(_d)\worldFTileIsInScreen=1
   __TOUCHMOVE_CONTROLLER(_d) 
   EndIf
   
   ;-----------------

  If _3DGFXOBJECT(_d)\useWeapon<>"" 
     __GET_EMITTEROBJECT_MAP(_d,_3DGFXOBJECT(_d)\worldFH,_3DGFXOBJECT(_d)\worldFV)
  EndIf
 
  ;##################################################
  
  ;############# SPECIALEFFECTS ###############
  
  If _3DGFXOBJECT(_d)\worldFTileFadeIn<>0
     __FADE_IN(_d)
  EndIf
  
  
   If _3DGFXOBJECT(_d)\worldFTileFadeOut<>0
     __FADE_OUT(_d)
  EndIf
  
  If _3DGFXOBJECT(_d)\worldFTileGoBack<>0
   __GOBACK(_d)
  EndIf
  
  
  
  ;###########################################
         
  ;declare/check all movings    
  
  ;in screen actions:
  
                             
  If  _3DGFXOBJECT(_d)\worldFTileCollision<>0 And _3DGFXOBJECT(_d)\worldFTileVELO<>0  ;check for moving objects only!
      __DEFAULT_COLLISION_DETECTION_MAP(_d)
  EndIf
  
   If _3DGFXOBJECT(_d)\worldFTIleIsInScreen=1
  
            If _3DGFXOBJECT(_d)\worldFTileFollowObject<>0
            If Random(_3DGFXOBJECT(_d)\worldFTileRandomFollow)=0 ; 
                __FOLLOWOBJECT_REGION(_3DGFXOBJECT(_d)\worldFTileFollow,_d)  ;try to follow specified object 
            EndIf    
            EndIf
            
            If _3DGFXOBJECT(_d.l)\worldFTileIsAnim<>0 And _3DGFXOBJECT(_d.l)\actualDirection=#MOVE_DEFAULT
                __ANIM_DEFAULT(_d.l)
            EndIf   
           
                         
         If _3DGFXOBJECT(_d)\worldFTileRotate<>0
         __LUCY_SUPEROTATE(_d, _3DGFXOBJECT(_d)\worldFTileW, _3DGFXOBJECT(_d)\worldFTileH,_3DGFXOBJECT(_d)\worldFTileAngle, 0,0)
         EndIf 
         
          If _3DGFXOBJECT(_d)\worldFTilePlayerID<>0  ;interact with the player cha
             __PLAYER_CONTROL(_d)
         EndIf  
   
   If _3DGFXOBJECT(_d.l)\worldFTileVELO<>0 
      __MOVE_OBJECT(_d)
   EndIf  
                   
    EndIf
   
  
 
 EndIf
   
   
    __OTHER_CONTROL(_d) 
       
EndProcedure

Procedure __OBJECT_INTERNALS(_d.l)
;some internals :
_3DGFXOBJECT(_d.l)\worldFTileCenterX=(_3DGFXOBJECT(_d.l)\worldFTileW/2)+_3DGFXOBJECT(_d.l)\worldFH
_3DGFXOBJECT(_d.l)\worldFTileCenterY=(_3DGFXOBJECT(_d.l)\worldFTileH/2)+_3DGFXOBJECT(_d.l)\worldFV
EndProcedure

 
 





Procedure __SGFX(_d)  ;core routine
;_i holds the object id of actual object
;place routines and if/cases to call specialised routines here
If _gameOver=#False

If _ingame_time=0 
 __RIGT_OBJECT(_d.l)  ;relativetimer ingame fps based
EndIf

 __OBJECT_TIMER(_d.l)

;__DNA_CONTROLLER(_d.l)

__OBJECT_INTERNALS(_d.l)


__PRESENTATION() ;used for intro/extro/credits....
;********************* CALL ROUTINES:

__OBJECT_MANAGER_MAP(_d)
__EXTERMINATION(_d) ;global object controller/remover!   
 
If _3DGFXOBJECT(_d)\worldFTileIsActive>0
   __THE_GAME(_d) ;the User GameRotuine Our Power! 
EndIf  
__GFXCONTROLLER(_d) 
EndIf   

 EndProcedure
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 1151
; FirstLine = 1151
; Folding = ----------
; EnableXP
; EnableOnError
; Executable = app03092012R1.exe
; CPU = 5
; SubSystem = DX9
; DisableDebugger